Scriptname _renn_NabeeKey extends Quest
{renn's Nabee}

GlobalVariable Property _NabeeLight Auto
GlobalVariable Property _NabeeLightNPC Auto
Actor Property PlayerRef Auto
Formlist Property _rennNabeeFLST_ArmorsCycle Auto ;24
int CycleSet = 10
int Property NabeeHotkey						= 63 Auto ;= F5
int Property NabeeCycleHotkey					= 64 Auto ;= F6
;bool Property b_NabeeHotkeyHold				= false Auto
;bool Property b_NabeeCycleHotkeyHold			= false Auto

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

event OnInit()
	RegisterForKey(NabeeHotkey)
	RegisterForKey(NabeeCycleHotkey)
endEvent

;event OnKeyDown(int keyCode)
;	if KeyCode == NabeeHotkey
;		_NabeeLight.SetValue(1 - _NabeeLight.GetValue())
;		Utility.Wait(2)
;	endif
;endEvent

event OnKeyUp(int keyCode, float HoldTime)
	if KeyCode == NabeeHotkey
		if HoldTime >= 0.3
			_NabeeLightNPC.SetValue(1 - _NabeeLightNPC.GetValue())
		else
			float NabeeLight = _NabeeLight.GetValue()
			_NabeeLight.SetValue(1 - NabeeLight)
			_NabeeLightNPC.SetValue(1 - NabeeLight)
		endif
		Utility.Wait(2)
	endif
	if KeyCode == NabeeCycleHotkey
		if PlayerRef.isEquipped(_rennNabeeFLST_ArmorsCycle)
			if HoldTime < 0.3
				ApplyNabeeCycle()
			else
				ApplyNabeeCycleRevert()
			endif
			Utility.Wait(2)
		endif
	endif
endEvent

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

function ApplyNabeeCycle()
	int i = 0
	bool found = false
	While i < (CycleSet * 3) && !found
		Armor NabeeArmorCurrent = _rennNabeeFLST_ArmorsCycle.GetAt(i) as Armor
		if PlayerRef.isEquipped(NabeeArmorCurrent)
			string s_NabeeArmorNext
			int j = i + CycleSet
			if i < CycleSet				;F -> L
				s_NabeeArmorNext = "$Left Plain Light Nabee..."
			elseif i < (CycleSet * 2)			;L -> R
				s_NabeeArmorNext = "$Right Plain Light Nabee..."
			elseif i >= (CycleSet * 2)			;R -> F
				s_NabeeArmorNext = "$Pure Light Nabee..."
				j = i - (CycleSet * 2)
			endif
			Armor NabeeArmorNext = _rennNabeeFLST_ArmorsCycle.GetAt(j) as Armor			
			Debug.Notification(s_NabeeArmorNext)
			PlayerRef.UnEquipItem(NabeeArmorCurrent, true, true)
			PlayerRef.RemoveItem(NabeeArmorCurrent, 1, true)
			Utility.Wait(1)
			PlayerRef.EquipItem(NabeeArmorNext, false, true)			
			found = true
		endif
	i += 1
	endWhile
endFunction

function ApplyNabeeCycleRevert()
	int i = 0
	bool found = false
	While i < (CycleSet * 3) && !found
		Armor NabeeArmorCurrent = _rennNabeeFLST_ArmorsCycle.GetAt(i) as Armor
		if PlayerRef.isEquipped(NabeeArmorCurrent)
			string s_NabeeArmorNext
			int j = i - CycleSet
			if i < CycleSet				;F -> R
				s_NabeeArmorNext = "$Right Plain Light Nabee..."
				j = i + (CycleSet * 2)
			elseif i < (CycleSet * 2)			;L -> F
				s_NabeeArmorNext = "$Pure Light Nabee..."
			elseif i >= (CycleSet * 2)			;R -> L
				s_NabeeArmorNext = "$Left Plain Light Nabee..."
			endif
			Armor NabeeArmorNext = _rennNabeeFLST_ArmorsCycle.GetAt(j) as Armor
			Debug.Notification(s_NabeeArmorNext)
			PlayerRef.UnEquipItem(NabeeArmorCurrent, true, true)
			PlayerRef.RemoveItem(NabeeArmorCurrent, 1, true)
			Utility.Wait(1)
			PlayerRef.EquipItem(NabeeArmorNext, false, true)			
			found = true
		endif
	i += 1
	endWhile
endFunction