Scriptname _renn_NabeeMCM extends SKI_ConfigBase
{renn's Nabee 4.23+}

;--------------------------------------------- Nabee GlobalVariable

GlobalVariable[] Property _NabeeBrightness_FF	Auto
GlobalVariable[] Property _NabeeBrightness_ST	Auto
GlobalVariable[] Property _NabeeBrightness_RT	Auto
GlobalVariable[] Property _Radius_FF_Var		Auto
GlobalVariable[] Property _Radius_ST_Var		Auto
GlobalVariable[] Property _Radius_RT_Var		Auto
GlobalVariable	Property _NabeeHouse_ST			Auto
GlobalVariable	Property _NabeeHouse_RT			Auto
GlobalVariable	Property _NabeeSneak_FF			Auto
GlobalVariable	Property _NabeeSneak_ST			Auto
GlobalVariable	Property _NabeeSneak_RT			Auto
GlobalVariable	Property _NabeeCraft_FF			Auto
GlobalVariable	Property _NabeeCraft_FFT		Auto
GlobalVariable	Property _NabeeCraft_ST			Auto
GlobalVariable	Property _NabeeCraft_T			Auto
GlobalVariable	Property _NabeeCraft_RT			Auto
GlobalVariable	Property _NabeeCraft_RR			Auto
GlobalVariable	Property _NabeeSneakValue_FF	Auto
GlobalVariable	Property _NabeeSneakValue_ST	Auto
GlobalVariable	Property _NabeeSneakValue_RT	Auto
GlobalVariable	Property _NabeeSneakValue_Night	Auto
GlobalVariable	Property _NabeeSneakValue_Dungeon	Auto
GlobalVariable	Property _NabeeLimit			Auto
GlobalVariable	Property _NabeeReactionTime		Auto
GlobalVariable	Property _7						Auto
GlobalVariable	Property _19					Auto
GlobalVariable	Property _ArmorWeightClass		Auto
GlobalVariable	Property _ArmorRating			Auto

;--------------------------------------------- Nabee Armor

Formlist Property _rennNabeeFLST_Armors		Auto	;32
Armor[]	_NabeeFF01_Armor	;0 - 5
Armor[]	_NabeeFF02_Armor	;6 - 11
Armor[]	_NabeeST01_Armor	;12 - 17
Armor[]	_NabeeST02_Armor	;18 - 23
Armor[]	_NabeeRT01_Armor	;24 - 26
Armor[]	_NabeeRT02_Armor	;27 - 29
Armor	_NabeeRR01_Armor	;30
Armor	_NabeeRR02_Armor	;31
Armor	NabeeArmor

;--------------------------------------------- Nabee Enchantment

Enchantment[] Property _rennNabeeFF01_Ench	Auto
Enchantment[] Property _rennNabeeFF02_Ench	Auto
Enchantment[] Property _rennNabeeST01_Ench	Auto
Enchantment[] Property _rennNabeeST02_Ench	Auto
Enchantment[] Property _rennNabeeRT01_Ench	Auto
Enchantment[] Property _rennNabeeRT02_Ench	Auto
Enchantment[] Property _rennNabeeRR01_Ench	Auto
Enchantment[] Property _rennNabeeRR02_Ench	Auto

;--------------------------------------------- Nabee Light

Light[] Property _rennNabeeFF01_Light	Auto
Light[] Property _rennNabeeFF02_Light	Auto
Light[] Property _rennNabeeST01_Light	Auto
Light[] Property _rennNabeeST02_Light	Auto
Light[] Property _rennNabeeRT01_Light	Auto
Light[] Property _rennNabeeRT02_Light	Auto

;--------------------------------------------- Nabee Spell

Spell[] Property _rennNabeeFF01_Spell		Auto
Spell[] Property _rennNabeeFF02_Spell		Auto
Spell[] Property _rennNabeeST01_Spell		Auto
Spell[] Property _rennNabeeST02_Spell		Auto
Spell[] Property _rennNabeeRT01_Spell		Auto
Spell[] Property _rennNabeeRT02_Spell		Auto
Spell[] Property _rennNabeeRR01_Spell		Auto
Spell[] Property _rennNabeeRR02_Spell		Auto
Spell[] Property _rennNabeeFF01L_Spell		Auto
Spell[] Property _rennNabeeFF02L_Spell		Auto
Spell[] Property _rennNabeeST01L_Spell		Auto
Spell[] Property _rennNabeeST02L_Spell		Auto
Spell[] Property _rennNabeeRT01L_Spell		Auto
Spell[] Property _rennNabeeRT02L_Spell		Auto
Spell[] Property _rennNabeeFF01R_Spell		Auto
Spell[] Property _rennNabeeFF02R_Spell		Auto
Spell[] Property _rennNabeeST01R_Spell		Auto
Spell[] Property _rennNabeeST02R_Spell		Auto
Spell[] Property _rennNabeeRT01R_Spell		Auto
Spell[] Property _rennNabeeRT02R_Spell		Auto

;--------------------------------------------- Nabee MagicEffect

MagicEffect[] Property _rennNabeeFF01_Effect	Auto
MagicEffect[] Property _rennNabeeFF02_Effect	Auto
MagicEffect[] Property _rennNabeeST01_Effect	Auto
MagicEffect[] Property _rennNabeeST02_Effect	Auto
MagicEffect[] Property _rennNabeeRT01_Effect	Auto
MagicEffect[] Property _rennNabeeRT02_Effect	Auto
MagicEffect[] Property _rennNabeeFF01L_Effect	Auto
MagicEffect[] Property _rennNabeeFF02L_Effect	Auto
MagicEffect[] Property _rennNabeeST01L_Effect	Auto
MagicEffect[] Property _rennNabeeST02L_Effect	Auto
MagicEffect[] Property _rennNabeeRT01L_Effect	Auto
MagicEffect[] Property _rennNabeeRT02L_Effect	Auto
MagicEffect[] Property _rennNabeeFF01R_Effect	Auto
MagicEffect[] Property _rennNabeeFF02R_Effect	Auto
MagicEffect[] Property _rennNabeeST01R_Effect	Auto
MagicEffect[] Property _rennNabeeST02R_Effect	Auto
MagicEffect[] Property _rennNabeeRT01R_Effect	Auto
MagicEffect[] Property _rennNabeeRT02R_Effect	Auto
MagicEffect[] Property _rennNabeeRR01_Effect	Auto
MagicEffect[] Property _rennNabeeRR02_Effect	Auto

;--------------------------------------------- Nabee General

Formlist Property _rennNabeeFLST_Temp Auto
Actor Property PlayerRef Auto
Actor Equipper
Actor NPC
int	_B_							;= 6	;_Brightness_
int _C_							;= 5	;_Condition_
;int _D_						;= 3	;_Direction_
;int _CC_						;= 2	;_Color_

;--------------------------------------------- Nabee Page

int[] Brightness_FF
int[] Brightness_ST
int[] Brightness_RT
int House_FF
int House_ST
int House_RT
int Sneak_FF
int Sneak_ST
int Sneak_RT
int[] BrightnessIndex_FF
int[] BrightnessIndex_ST
int[] BrightnessIndex_RT
int HouseIndex_ST
int HouseIndex_RT
int SneakIndex_FF
int SneakIndex_ST
int SneakIndex_RT
int[] Radius_FF
int[] Radius_ST
int[] Radius_RT
int[] Radius_FF_Var
int[] Radius_ST_Var
int[] Radius_RT_Var
string[] BrightnessListGroup
string[] BrightnessList
string[] HouseList
string[] SneakList_FF
string[] SneakList
bool b_ApplyNabeeRefresh		= false
bool b_ApplyNabeeEnchFF			= false
bool b_ApplyNabeeEnchST			= false
bool b_ApplyNabeeEnchRT			= false
bool b_ApplyNabeeSpellFF		= false
bool b_ApplyNabeeSpellST		= false
bool b_ApplyNabeeSpellRT		= false
bool b_ApplyNabeeRadiusFF		= false
bool b_ApplyNabeeRadiusST		= false
bool b_ApplyNabeeRadiusRT		= false

;--------------------------------------------- Craft Page

int Craft_FF
int Craft_ST
int Craft_T
int Craft_RT
int Craft_RR
int[] Craft_PureLight
int[] Craft_PlainLight
bool[] b_Craft_PureLight
bool[] b_Craft_PlainLight
bool b_NabeeCraftValue			= false
int OID_WeightClass
int OID_ArmorRating
int i_WeightClass				= 2
int ArmorRating_Var				= 0
string[] WeightClassMenuList
bool b_ApplyNabeeClass			= false

;--------------------------------------------- ETC Page

Perk Property _rennNabeeSneakFF_Perk Auto
Perk Property _rennNabeeSneakST_Perk Auto
Perk Property _rennNabeeSneakRT_Perk Auto
Perk Property _rennNabeeNight_Perk Auto
Perk Property _rennNabeeDungeon_Perk Auto
Spell Property _rennHiddenInventorySpell Auto

int SneakValue_FF
int SneakValue_ST
int SneakValue_RT
int SneakValue_Dungeon
int SneakValue_Night
float SneakValue_FF_Var 		= 25.0
float SneakValue_ST_Var 		= 35.0
float SneakValue_RT_Var 		= 35.0
float SneakValue_Dungeon_Var	= 20.0
float SneakValue_Night_Var 		= 20.0
bool b_NabeeSneakValue 			= false

int BrightnessHelp
int Credit
int InventorySpell
int ShowLocation
bool b_InventorySpell			= false
bool b_ShowLocation				= true
int ResetAll
int ReactionTime
int Daytime_0
int Daytime_1
int DebugMSG
int i_DebugMSG					= 1
bool Property b_Init			= false Auto

;--------------------------------------------- NPCs Page

Formlist Property _rennNabeeFLST_NPCs Auto
Faction Property _rennNabeeNPC_Faction Auto
Faction Property CurrentFollowerFaction Auto

int[] NPC_X
int[] NPC_T
int[] i_NPCNabee
int NabeeLimit
bool b_ArrangeNPC				= false
bool[] b_NPC_X
string[] s_NPC_X

;--------------------------------------------- Dwelling Page

Formlist Property _rennNabeeFLST_Dwelling Auto
Formlist Property _rennNabeeFLST_DwellingX Auto
Formlist Property _rennNabeeFLST_DwellingXDLC Auto
Formlist Property _rennNabeeFLST_DwellingDefault Auto
Formlist Property _rennNabeeFLST_DwellingXDefault Auto
Keyword Property LocTypeDwelling Auto
Keyword Property LocTypeDungeon Auto

int[] Dwelling_
int[] DwellingX_
bool[] b_Dwelling_
bool[] b_DwellingX_
int i_Dwelling_					= 0
int i_DwellingX_				= 0
int DwellingLimit
int DwellingXLimit
string[] DwellingMenuList
string[] DwellingXMenuList
bool b_ArrangeDwelling			= false
bool b_ArrangeDwellingX			= false
Location Dwelling
Location CurrentLocation
int i_DG						= 0

;--------------------------------------------- HotKeys

_renn_NabeeKey Property NabeeKey Auto
int NabeeHotkeyEnable
bool b_NabeeHotkeyEnable
int NabeeHotkeyOID
int NabeeCycleHotkeyOID

;--------------------------------------------- FISS

int saveFISS_OID
int loadFISS_OID
int loadFISSDwelling_OID
bool b_loadFISSDwelling

;==========================================================================================================
; Open & Close
;==========================================================================================================

;event OnGameReload()
;	parent.OnGameReload()
;	NabeeReload()
;endEvent

event OnConfigInit()	
	ModName						= "Dwemer Nabee"
	Pages						= new string[14]
	Pages[0]					= "$Nabee Setting"
	Pages[1]					= "$Nabee Style"
	Pages[2]					= "$Nabee Management"
	Pages[3]					= ""
	Pages[4]					= "$Nabee NPC List 1"			;01-10 = 1
	Pages[5]					= "$Nabee NPC List 2"			;11-20 = 2
	Pages[6]					= "$Nabee NPC List 3"			;21-30 = 3
	Pages[7]					= ""
	Pages[8]					= "$Register Non-Dwelling 1"	;01-30 = 1
	Pages[9]					= "$Register Non-Dwelling 2"	;31-60 = 2
	Pages[10]					= "$Register Non-Dwelling 3"	;61-90 = 3
	Pages[11]					= ""
	Pages[12]					= "$Register Dwelling 1"		;01-30 = 1
	Pages[13]					= "$Register Dwelling 2"		;31-60 = 2	
endEvent

function ReadPages()
	BrightnessListGroup			= new string[7]	;_Brightness_ + 1
	BrightnessListGroup[0]		= "Group Brightness + 0"
	BrightnessListGroup[1]		= "Group Brightness + 1"
	BrightnessListGroup[2]		= "Group Brightness + 2"
	BrightnessListGroup[3]		= "Group Brightness + 3"
	BrightnessListGroup[4]		= "Group Brightness - 1"
	BrightnessListGroup[5]		= "Group Brightness - 2"
	BrightnessListGroup[6]		= "Individual Brightness"
	BrightnessList				= new string[6]	;_Brightness_
	BrightnessList[0]			= "$Brightness + 0"
	BrightnessList[1]			= "$Brightness + 1"
	BrightnessList[2]			= "$Brightness + 2"
	BrightnessList[3]			= "$Brightness + 3"
	BrightnessList[4]			= "$Brightness - 1"
	BrightnessList[5]			= "$Brightness - 2"
	HouseList					= new string[2]
	HouseList[0]				= "$Light Darker"
	HouseList[1]				= "$Face Light"
	SneakList					= new string[4]
	SneakList[0]				= "$Light Off.."
	SneakList[1]				= "$Face Light"
	SneakList[2]				= "$Light Darker"
	SneakList[3]				= "$No Change"
	SneakList_FF				= new string[2]
	SneakList_FF[0]				= "$Light Off.."
	SneakList_FF[1]				= "$Face Light"	
	Brightness_FF				= new int[10]	;7 _Condition_ + 1 (Group) + 1 (Dwelling)
	Brightness_ST				= new int[10]	;6 _Condition_ + 1 (Group)
	Brightness_RT				= new int[10]	;6
	BrightnessIndex_FF			= new int[10]	;6 _Condition_ + 1 (Group)
	BrightnessIndex_ST			= new int[10]	;6 _Condition_ + 1 (Group)
	BrightnessIndex_RT			= new int[10]	;6
	Radius_FF					= new int[10]	;7 _Condition_ + 1 (Group) + 1 (Dwelling)
	Radius_ST					= new int[10]	;6
	Radius_RT					= new int[10]	;6
	Radius_FF_Var				= new int[10]	;6 _Condition_ + 1 (Group)
	Radius_ST_Var				= new int[10]	;6 _Condition_ + 1 (Group)
	Radius_RT_Var				= new int[10]	;6	
	HouseIndex_ST				= 1
	HouseIndex_RT				= 1
	SneakIndex_FF				= 1
	SneakIndex_ST				= 2
	SneakIndex_RT				= 2
	_B_							= 6 ;_Brightness_
	_C_							= 5	;_Condition_
	Craft_PureLight				= new int[6]	;Nabee FF, FFT, ST, STT, RT, RR
	Craft_PlainLight			= new int[6]
	b_Craft_PureLight			= new bool[6]
	b_Craft_PlainLight			= new bool[6]
	b_Craft_PureLight[0]		= _NabeeCraft_FF.GetValue() as bool
	b_Craft_PureLight[1]		= _NabeeCraft_FFT.GetValue() as bool
	b_Craft_PureLight[2]		= _NabeeCraft_ST.GetValue() as bool
	b_Craft_PureLight[3]		= _NabeeCraft_T.GetValue() as bool
	b_Craft_PureLight[4]		= _NabeeCraft_RT.GetValue() as bool
	b_Craft_PureLight[5]		= _NabeeCraft_RR.GetValue() as bool
	i = 0
	While i < 6
		b_Craft_PlainLight[i]	= false
		i += 1
	endWhile
	SneakValue_ST_Var			= _NabeeSneakValue_ST.GetValue() as int
	SneakValue_RT_Var			= _NabeeSneakValue_RT.GetValue() as int
	SneakValue_FF_Var			= _NabeeSneakValue_FF.GetValue() as int
	SneakValue_Night_Var		= _NabeeSneakValue_Night.GetValue() as int
	WeightClassMenuList			= new string[3]
	WeightClassMenuList[0]		= "$Light Armor"
	WeightClassMenuList[1]		= "$Heavy Armor"
	WeightClassMenuList[2]		= "$Clothing"
	
	NabeeLimit					= _NabeeLimit.GetValue() as int ;30
	NPC_X						= new int[31]
	NPC_T						= new int[31]
	i_NPCNabee					= new int[30]
	b_NPC_X						= new bool[30]
	s_NPC_X						= new string[5]
	s_NPC_X[0]					= "$(Cancel)"
	s_NPC_X[1]					= "$Selected NPCs: Get Back Nabees"
	s_NPC_X[2]					= "$Selected NPCs: Unregister"
	s_NPC_X[3]					= "$All NPCs: Get Back Nabees"
	s_NPC_X[4]					= "$All NPCs: Unregister"
	
	DwellingLimit				= 60
	DwellingXLimit				= 90
	Dwelling_					= new int[64]
	DwellingX_					= new int[94]
	b_Dwelling_					= new bool[60]
	b_DwellingX_				= new bool[90]
	DwellingMenuList			= new string[3]
	DwellingMenuList[0]			= "$(Cancel)"
	DwellingMenuList[1]			= "$Clear List"
	DwellingMenuList[2]			= "$Add Default Dwelling List"
	DwellingXMenuList			= new string[4]
	DwellingXMenuList[0]		= "$(Cancel)"
	DwellingXMenuList[1]		= "$Clear List"
	DwellingXMenuList[2]		= "$Add Default Non-Dwelling List"
	DwellingXMenuList[3]		= "$Add DLC Default Non-Dwelling List"
	
	int i = 0
	While i < _rennNabeeFLST_DwellingXDefault.GetSize()
		Dwelling = _rennNabeeFLST_DwellingXDefault.GetAt(i) as Location
		_rennNabeeFLST_DwellingX.AddForm(Dwelling)
		i += 1
	endWhile
	;i = 0
	;While i < _rennNabeeFLST_DwellingDefault.GetSize()
	;	Dwelling = _rennNabeeFLST_DwellingDefault.GetAt(i) as Location
	;	_rennNabeeFLST_Dwelling.AddForm(Dwelling)
	;	i += 1
	;endWhile
	
	_NabeeFF01_Armor			= new Armor[6]			;6	_Direction_ 3 * _Visible_ 2
	_NabeeFF02_Armor			= new Armor[6]
	_NabeeST01_Armor			= new Armor[6]			;6	_Direction_ 3 * _Visible_ 2
	_NabeeST02_Armor			= new Armor[6]
	_NabeeRT01_Armor			= new Armor[3]			;3	_Direction_ 3 * _Visible_ 1
	_NabeeRT02_Armor			= new Armor[3]	
	i = 0
	While i < 6
		if i < 3
			_NabeeRT01_Armor[i] = _rennNabeeFLST_Armors.GetAt(i + 24) as Armor
			_NabeeRT02_Armor[i] = _rennNabeeFLST_Armors.GetAt(i + 27) as Armor
		endif
		_NabeeFF01_Armor[i]	 	= _rennNabeeFLST_Armors.GetAt(i) as Armor
		_NabeeFF02_Armor[i] 	= _rennNabeeFLST_Armors.GetAt(i + 6) as Armor
		_NabeeST01_Armor[i] 	= _rennNabeeFLST_Armors.GetAt(i + 12) as Armor
		_NabeeST02_Armor[i] 	= _rennNabeeFLST_Armors.GetAt(i + 18) as Armor
		i += 1
	endWhile
	_NabeeRR01_Armor			= _rennNabeeFLST_Armors.GetAt(30) as Armor
	_NabeeRR02_Armor			= _rennNabeeFLST_Armors.GetAt(31) as Armor	
	ReadValue()
endFunction

;event OnVersionUpdate(int a_version)
;	if (a_version >= 2 && CurrentVersion < 2)
;		OnConfigInit()
;	endif
;endEvent

;int Function GetVersion()
;    return 2 ;version 4.23
;endFunction

function NabeeReload()
	float Time_0 = Utility.GetCurrentRealTime()
	ReadValue()
	if ReadReload()
		if i_DebugMSG > 0
			Debug.Notification("Dwemer Nabee: " + "Adapting to environment...")
		endif
		NabeeRefresh_0()	;================ Light OFF
		ApplyReload()
		NabeeRefresh_1()	;================ Light ON
	endif
	ApplyReload2()
	float Time_1 = Utility.GetCurrentRealTime()
	if i_DebugMSG == 2
		Debug.Notification("Dwemer Nabee: " + (Time_1 - Time_0) + "seconds. " + "Finished adapting.")
		;Debug.Notification("Dwemer Nabee: " + "Finished adapting.")
	endif
	ApplyAllDone()
endFunction

function ReadValue()
	int i = 0
	While i < 6 	;_Condition_ + 1
		BrightnessIndex_FF[i]	= _NabeeBrightness_FF[i].GetValue() as int
		BrightnessIndex_ST[i]	= _NabeeBrightness_ST[i].GetValue() as int
		BrightnessIndex_RT[i]	= _NabeeBrightness_RT[i].GetValue() as int
		Radius_FF_Var[i]		= _Radius_FF_Var[i].GetValue() as int
		Radius_ST_Var[i]		= _Radius_ST_Var[i].GetValue() as int
		Radius_RT_Var[i]		= _Radius_RT_Var[i].GetValue() as int
		i += 1
	endWhile
	i_WeightClass				= _ArmorWeightClass.GetValue() as int
	ArmorRating_Var				= _ArmorRating.GetValue() as int
endFunction

function SaveValue()
	int i = 0
	While i < 6 	;_Condition_ + 1
		_NabeeBrightness_FF[i].SetValue(BrightnessIndex_FF[i])
		_NabeeBrightness_ST[i].SetValue(BrightnessIndex_ST[i])
		_NabeeBrightness_RT[i].SetValue(BrightnessIndex_RT[i])
		_Radius_FF_Var[i].SetValue(Radius_FF_Var[i])
		_Radius_ST_Var[i].SetValue(Radius_ST_Var[i])
		_Radius_RT_Var[i].SetValue(Radius_RT_Var[i])
		i += 1
	endWhile
	_ArmorWeightClass.SetValue(i_WeightClass)
	_ArmorRating.SetValue(ArmorRating_Var)
endFunction

bool function ReadReload()
	_C_ = 5
	int i_Reload = 0
	if BrightnessIndex_FF[_C_]	!= 0
		b_ApplyNabeeSpellFF		= true
		i_Reload += 1
	endif
	if BrightnessIndex_ST[_C_]	!= 0
		b_ApplyNabeeSpellST		= true
		i_Reload += 1
	endif
	if BrightnessIndex_RT[_C_]	!= 0
		b_ApplyNabeeSpellRT		= true
		i_Reload += 1
	endif
	if Radius_FF_Var[_C_]		== 1
		b_ApplyNabeeRadiusFF	= true
		i_Reload += 1
	endif
	if Radius_ST_Var[_C_]		== 1
		b_ApplyNabeeRadiusST	= true
		i_Reload += 1
	endif
	if Radius_RT_Var[_C_]		== 1
		b_ApplyNabeeRadiusRT	= true
		i_Reload += 1
	endif
	if i_WeightClass			!= 2
		b_ApplyNabeeClass		= true
	endif
	b_NabeeSneakValue			= true
	if i_Reload > 0
		return true
	else
		return false
	endif
endFunction

function ApplyReload()
	if b_ApplyNabeeRadiusFF
		if i_DebugMSG == 2
			Debug.Notification("ApplyNabeeRadiusFF...")
		endif
		ApplyNabeeRadiusFF()
	endif
	if b_ApplyNabeeRadiusST
		if i_DebugMSG == 2
			Debug.Notification("ApplyNabeeRadiusST...")
		endif
		ApplyNabeeRadiusST()
	endif
	if b_ApplyNabeeRadiusRT
		if i_DebugMSG == 2
			Debug.Notification("ApplyNabeeRadiusRT...")
		endif
		ApplyNabeeRadiusRT()
	endif
	if b_ApplyNabeeSpellFF
		if i_DebugMSG == 2
			Debug.Notification("ApplyNabeeSpellFF...")
		endif
		ApplyNabeeSpellFF()
	endif
	if b_ApplyNabeeSpellST
		if i_DebugMSG == 2
			Debug.Notification("ApplyNabeeSpellST...")
		endif
		ApplyNabeeSpellST()
	endif
	if b_ApplyNabeeSpellRT
		if i_DebugMSG == 2
			Debug.Notification("ApplyNabeeSpellRT...")
		endif
		ApplyNabeeSpellRT()
	endif
endFunction

function ApplyReload2()
	if b_ApplyNabeeClass
		if ApplyWeightClass()
			if i_DebugMSG == 2
				Debug.Notification("ApplyNabeeClass...")
			endif
			ApplyArmorRating()
		endif
	endif
	if b_NabeeSneakValue
		if i_DebugMSG == 2
			Debug.Notification("ApplyNabeeSneakValue...")
		endif
		ApplyNabeeSneakValue()
	endif
endFunction

event OnConfigOpen()
	ApplyAllDone()
endEvent

event OnConfigClose()
	if b_NabeeHotkeyEnable
		UnregisterForAllKeys()
		RegisterForKey(NabeeKey.NabeeHotkey)
		RegisterForKey(NabeeKey.NabeeCycleHotkey)
		NabeeKey.Start()
	else
		UnregisterForAllKeys()
		NabeeKey.Stop()
	endif
	if !b_ApplyNabeeRefresh
		if b_ApplyNabeeEnchFF || b_ApplyNabeeEnchST || b_ApplyNabeeEnchRT || b_ApplyNabeeSpellFF || b_ApplyNabeeSpellST || b_ApplyNabeeSpellRT || b_ApplyNabeeRadiusFF || b_ApplyNabeeRadiusST || b_ApplyNabeeRadiusRT
			b_ApplyNabeeRefresh = true
		endif
	endif
	if b_ApplyNabeeRefresh
		NabeeRefresh_0()
		if i_DebugMSG > 0
			Debug.Notification("Dwemer Nabee: " + "Changing Lights...")
		endif
		;------------------- Radius, Spell
		ApplyReload()
		;------------------- Enchantment
		if b_ApplyNabeeEnchFF || b_ApplyNabeeEnchST || b_ApplyNabeeEnchRT
			if b_ApplyNabeeEnchFF
				if i_DebugMSG == 2
					Debug.Notification("ApplyNabeeEnchFF...")
				endif
				ApplyNabeeEnchFF()
			endif
			if b_ApplyNabeeEnchST
				if i_DebugMSG == 2
					Debug.Notification("ApplyNabeeEnchST...")
				endif
				ApplyNabeeEnchST()
			endif
			if b_ApplyNabeeEnchRT
				if i_DebugMSG == 2
					Debug.Notification("ApplyNabeeEnchRT...")
				endif
				ApplyNabeeEnchRT()
			endif
			NabeeRefresh()
		endif
		;-------------------
		NabeeRefresh_1()
	endif
	if b_NabeeCraftValue
		NabeeCraftValue()
	endif
	if b_NabeeSneakValue
		NabeeSneakValue()
	endif
	ApplyReload2()
	ApplyAllDone()
	if b_InventorySpell
		if !PlayerRef.HasSpell(_rennHiddenInventorySpell)
			PlayerRef.AddSpell(_rennHiddenInventorySpell)
		endif
	else
		PlayerRef.RemoveSpell(_rennHiddenInventorySpell)
	endif
	if b_ArrangeNPC || b_ArrangeDwelling || b_ArrangeDwellingX
		if i_DebugMSG > 0
			Debug.Notification("Dwemer Nabee: " + "Starting arrangement. Please wait...")
			;Debug.Notification("Dwemer Nabee: " + "Removing disabled NPCs and Locations...")
		endif
		if b_ArrangeNPC
			if i_DebugMSG == 2
				Debug.Notification("ArrangeNPC...")
			endif
			ArrangeNPC()
			b_ArrangeNPC		= false
		endif
		if b_ArrangeDwelling
			if i_DebugMSG == 2
				Debug.Notification("ArrangeDwelling...")
			endif
			ArrangeDwelling()
			b_ArrangeDwelling	= false
		endif
		if b_ArrangeDwellingX
			if i_DebugMSG == 2
				Debug.Notification("ArrangeDwellingX...")
			endif
			ArrangeDwellingX()
			b_ArrangeDwellingX	= false
		endif
		if i_DebugMSG > 0
			Debug.Notification("Dwemer Nabee: " + "Finished arrangement.")
		endif
	endif
	SaveValue()
endEvent

bool function Check_DLC()
	if Game.GetModByName("Dawnguard.esm") == 255
		_rennNabeeFLST_DwellingXDLC.Revert()
		i_DG = 0
		return false
	else
		if _rennNabeeFLST_DwellingXDLC.GetSize() < 6
			_rennNabeeFLST_DwellingXDLC.AddForm(Game.GetFormFromFile(0x0200A87C, "Dawnguard.esm")) ;FalmerValleyLocation
			;_rennNabeeFLST_DwellingXDLC.AddForm(Game.GetFormFromFile(0x020162B0, "Dawnguard.esm")) ;FalmerValley01Location
			;_rennNabeeFLST_DwellingXDLC.AddForm(Game.GetFormFromFile(0x020162B2, "Dawnguard.esm")) ;FalmerValley02Location
			;_rennNabeeFLST_DwellingXDLC.AddForm(Game.GetFormFromFile(0x020162B4, "Dawnguard.esm")) ;FalmerValley03Location
			_rennNabeeFLST_DwellingXDLC.AddForm(Game.GetFormFromFile(0x0201379F, "Dawnguard.esm")) ;FalmerValleyTempleLocation
			_rennNabeeFLST_DwellingXDLC.AddForm(Game.GetFormFromFile(0x02003b8F, "Dawnguard.esm")) ;SoulCairn
			_rennNabeeFLST_DwellingXDLC.AddForm(Game.GetFormFromFile(0x020162AC, "Dawnguard.esm")) ;DarkfallPassage
			_rennNabeeFLST_DwellingXDLC.AddForm(Game.GetFormFromFile(0x0200357E, "Dawnguard.esm")) ;VampireCastleDungeon
			_rennNabeeFLST_DwellingXDLC.AddForm(Game.GetFormFromFile(0x0200357D, "Dawnguard.esm")) ;VampireCastleGuildhall
			Debug.Notification("Dwemer Nabee: " + "Dawnguard List Registered.")
		endif
		return true
	endif
endfunction

function Apply_DLC()
	int i = 0
	int DwellingXDLCSize = _rennNabeeFLST_DwellingXDLC.GetSize()
	if DwellingXDLCSize > DwellingXLimit - _rennNabeeFLST_DwellingX.GetSize()
		DwellingXDLCSize = DwellingXLimit - _rennNabeeFLST_DwellingX.GetSize()
	endif
	While i < DwellingXDLCSize
		Dwelling = _rennNabeeFLST_DwellingXDLC.GetAt(i) as Location
		if !_rennNabeeFLST_DwellingX.HasForm(Dwelling)
			if _rennNabeeFLST_Dwelling.HasForm(Dwelling) && i_DG > 0
				if ShowMessage(Dwelling.GetName() + "\n\n" + "This location is already registered as Dwelling.\n" + "Do you really want to Register this location as Non-Dwelling?", true)
					_rennNabeeFLST_Dwelling.RemoveAddedForm(Dwelling)
					_rennNabeeFLST_DwellingX.AddForm(Dwelling)
				endif
			else
				_rennNabeeFLST_DwellingX.AddForm(Dwelling)
			endif
		endif
		i += 1
	endWhile
	i_DG = 1
endfunction

;==========================================================================================================
; Pages
;==========================================================================================================

event OnPageReset(String a_page)
	
	GotoState("")
	if !b_Init
		Credit = AddTextOption("", "Activate MCM")
	else
	;==========================================================================
	if a_page == Pages[0] || a_page == "" ;Nabee Setting
		
		GotoState("NabeeSettingState")
		SetCursorFillMode(TOP_TO_BOTTOM)
		
		SetCursorPosition(0)
		BrightnessHelp = AddTextOption("Nabee Brightness Help", "")		
		
		int i
		string s_NabeeFF		= "Nabee FF"
		string s_NabeeST		= "Nabee ST"
		string s_NabeeRT		= "Nabee RT"
		string s_NabeeT			= "Nabee T"
		string s_Brightness_All	= "GROUP Brightness"
		string s_Radius_All		= "GROUP Radius"
		string s_Status_Dwelling= "Dwelling Status"
		string s_Status_Sneak	= "Sneak Status"
		string s_Widelight_0 	= "Wide Light: "
		string s_Facelight_0 	= "Face Light: "
		string s_Widelight_1	= "  (Wide Light)"
		string s_Facelight_1	= "  (Face Light)"
		string s_Commonlight	= "  (Common Light)"
		string s_C				= "   "
		string s_C0				= s_C + ": General"
		string s_C1				= s_C + ": Dwelling"
		string s_C2				= s_C + ": DwellingX"
		string s_C3				= s_C + ": Night"
		string s_C4				= s_C + ": Sneaking"
		string s_C5				= s_C + ": Clear Day"
		string s_C6				= s_C + ": Cloudy Day"
		string[] s_
		string[] s_FF
		s_						= new string[5]		;_Condition_
		s_[0]					= s_C0
		s_[1]					= s_C1
		s_[2]					= s_C2
		s_[3]					= s_C3
		s_[4]					= s_C4
		s_FF					= new string[6]		;_Condition_
		s_FF[0]					= s_C0
		s_FF[1]					= s_C5	+ s_Commonlight
		s_FF[2]					= s_C6	+ s_Commonlight
		s_FF[3]					= s_C3
		s_FF[4]					= s_C4	+ s_Facelight_1
		s_FF[5]					= s_C1	+ s_Facelight_1
		string s_font_0			= " (( "
		string s_font_1			= " )) "
				
		;===========================================================================
		; Detail Mod - Brightness
		;===========================================================================
			
		SetCursorPosition(2)
		
		AddHeaderOption(s_Facelight_0 + s_NabeeRT + ", Common")
		Sneak_FF = AddMenuOption(s_Status_Sneak, SneakList_FF[SneakIndex_FF])
		Brightness_FF[_C_] = AddMenuOption(s_Brightness_All, s_font_0 + BrightnessListGroup[BrightnessIndex_FF[_C_]] + s_font_1)
		i = 0
		While i < _C_ - 1		;Sneaking is for Widelight
			Brightness_FF[i] = AddMenuOption(s_FF[i], BrightnessList[BrightnessIndex_FF[i]])
			i += 1
		endWhile
		
		;===============================================
		; Nabee ST Brightness
		
		AddHeaderOption(s_Widelight_0 + s_NabeeST + ", " + s_NabeeT)
		Sneak_ST = AddMenuOption(s_Status_Sneak, SneakList[SneakIndex_ST])
		Brightness_ST[_C_] = AddMenuOption(s_Brightness_All, s_font_0 + BrightnessListGroup[BrightnessIndex_ST[_C_]] + s_font_1)
		i = 0
		While i < _C_
			if i == 1
				; HouseIndex_ST 1 = Face, 0 = Dark
				if HouseIndex_ST == 0
					Brightness_ST[i] = AddMenuOption(s_[i], BrightnessList[BrightnessIndex_ST[i]])
				else
					Brightness_ST[i] = AddMenuOption(s_FF[5], BrightnessList[BrightnessIndex_FF[0]])
				endif
			elseif i == 4
				; SneakIndex_ST 1 = Face, 2 = Dark, 3 = No Change
				if SneakIndex_ST == 0 || SneakIndex_ST == 3
					Brightness_ST[i] = AddMenuOption(s_[i], BrightnessList[BrightnessIndex_ST[i]], 1)
				elseif SneakIndex_ST == 1
					Brightness_ST[i] = AddMenuOption(s_FF[i], BrightnessList[BrightnessIndex_FF[i]])
				else
					Brightness_ST[i] = AddMenuOption(s_[i], BrightnessList[BrightnessIndex_ST[i]])
				endif
			else
				Brightness_ST[i] = AddMenuOption(s_[i], BrightnessList[BrightnessIndex_ST[i]])
			endif
			i += 1
		endWhile
		
		;===========================================
		; Nabee RT Brightness
		
		AddHeaderOption(s_Widelight_0 + s_NabeeRT)
		Sneak_RT = AddMenuOption(s_Status_Sneak, SneakList[SneakIndex_RT])
		Brightness_RT[_C_] = AddMenuOption(s_Brightness_All, s_font_0 + BrightnessListGroup[BrightnessIndex_RT[_C_]] + s_font_1)
		i = 0
		While i < _C_
			if i == 1
				; HouseIndex_RT 1 = Face, 0 = Dark
				if HouseIndex_RT == 0
					Brightness_RT[i] = AddMenuOption(s_[i], BrightnessList[BrightnessIndex_RT[i]])
				else
					Brightness_RT[i] = AddMenuOption(s_FF[5], BrightnessList[BrightnessIndex_FF[0]])
				endif
			elseif i == 4
				; SneakIndex_RT 1 = Face, 2 = Dark, 3 = No Change
				if SneakIndex_RT == 0 || SneakIndex_RT == 3
					Brightness_RT[i] = AddMenuOption(s_[i], BrightnessList[BrightnessIndex_RT[i]], 1)
				elseif SneakIndex_RT == 1
					Brightness_RT[i] = AddMenuOption(s_FF[i], BrightnessList[BrightnessIndex_FF[i]])
				else
					Brightness_RT[i] = AddMenuOption(s_[i], BrightnessList[BrightnessIndex_RT[i]])
				endif
			else
				Brightness_RT[i] = AddMenuOption(s_[i], BrightnessList[BrightnessIndex_RT[i]])
			endif
			i += 1
		endWhile
			
		;===========================================================================
		; Detail Mod - Radius
		;===========================================================================
			
		SetCursorPosition(3)
	
		AddHeaderOption("")
		AddEmptyOption()
		Radius_FF[_C_] = AddTextOption(s_Radius_All, "Radius Reset")
		i = 0
		While i < _C_ - 1
			Radius_FF[i] = AddSliderOption(s_FF[i], Radius_FF_Var[i])
			i += 1
		endWhile
		
		;===========================================
		; Nabee ST Radius
		
		AddHeaderOption("")
		House_ST = AddMenuOption(s_Status_Dwelling, HouseList[HouseIndex_ST])
		Radius_ST[_C_] = AddTextOption(s_Radius_All, "Radius Reset")
		i = 0
		While i < _C_
			if i == 1
				; HouseIndex_ST 1 = Face, 0 = Dark
				if HouseIndex_ST == 0
					Radius_ST[i] = AddSliderOption(s_[i], Radius_ST_Var[i])
				else
					Radius_ST[i] = AddSliderOption(s_FF[5], Radius_FF_Var[0])
				endif
			elseif i == 4
				; SneakIndex_ST 1 = Face, 2 = Dark, 3 = No Change
				if SneakIndex_ST == 0
					Radius_ST[i] = AddSliderOption(s_[i], Radius_ST_Var[i], 1)
				elseif SneakIndex_ST == 1
					Radius_ST[i] = AddSliderOption(s_FF[i], Radius_FF_Var[i])
				else
					Radius_ST[i] = AddSliderOption(s_[i], Radius_ST_Var[i])
				endif
			else
				Radius_ST[i] = AddSliderOption(s_[i], Radius_ST_Var[i])
			endif
			i += 1
		endWhile
		
		;===========================================
		; Nabee RT Radius
		
		AddHeaderOption("")
		House_RT = AddMenuOption(s_Status_Dwelling, HouseList[HouseIndex_RT])
		Radius_RT[_C_] = AddTextOption(s_Radius_All, "Radius Reset")
		i = 0
		While i < _C_
			if i == 1
				; HouseIndex_RT 1 = Face, 0 = Dark
				if HouseIndex_RT == 0
					Radius_RT[i] = AddSliderOption(s_[i], Radius_RT_Var[i])
				else
					Radius_RT[i] = AddSliderOption(s_FF[5], Radius_FF_Var[0])
				endif
			elseif i == 4
				; SneakIndex_RT 1 = Face, 2 = Dark, 3 = No Change
				if SneakIndex_RT == 0
					Radius_RT[i] = AddSliderOption(s_[i], Radius_RT_Var[i], 1)
				elseif SneakIndex_RT == 1
					Radius_RT[i] = AddSliderOption(s_FF[i], Radius_FF_Var[i])
				else
					Radius_RT[i] = AddSliderOption(s_[i], Radius_RT_Var[i])
				endif
			else
				Radius_RT[i] = AddSliderOption(s_[i], Radius_RT_Var[i])
			endif
			i += 1
		endWhile
			
;		AddEmptyOption()
;		AddHeaderOption("", 1)
;		AddTextOption("Current " + "Nabee NPC: Total " + _rennNabeeFLST_NPCs.GetSize() + " / " + NabeeLimit, (NabeeLimit - _rennNabeeFLST_NPCs.GetSize()) + " slot")
			
	;==========================================================================
	elseif a_page == Pages[1] ;Nabee Style / Crafting
		
		GotoState("NabeeCraftState")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		
		string s_Widelight_0 = "   " + "Wide Light: "
		string s_Facelight_0 = "   " + "Face Light: "
		string s_CraftPurelight = "Pure Light"
		string s_CraftPlainlight = "Plain Lights"
		
		AddHeaderOption("Nabee RT")
		Craft_RT = AddTextOption("Nabee RT", "2 Colors")
		Craft_PureLight[4] = AddToggleOption(s_Widelight_0 + s_CraftPurelight, b_Craft_PureLight[4])
		Craft_PlainLight[4] = AddToggleOption(s_Widelight_0 + s_CraftPlainlight, b_Craft_PlainLight[4])
		Craft_PureLight[0] = AddToggleOption(s_Facelight_0 + s_CraftPurelight, b_Craft_PureLight[0])
		Craft_PlainLight[0] = AddToggleOption(s_Facelight_0 + s_CraftPlainlight, b_Craft_PlainLight[0])
		;AddEmptyOption()
		Craft_RR = AddTextOption("Nabee RR", "2 Colors")
		Craft_PureLight[5] = AddToggleOption("   " + "Rotating Light: " + s_CraftPurelight, b_Craft_PureLight[5])
		
		AddHeaderOption("Nabee ST")
		Craft_ST = AddTextOption("Nabee ST", "2 Colors")
		Craft_PureLight[2] = AddToggleOption(s_Widelight_0 + s_CraftPurelight, b_Craft_PureLight[2])
		Craft_PlainLight[2] = AddToggleOption(s_Widelight_0 + s_CraftPlainlight, b_Craft_PlainLight[2])
		
		SetCursorPosition(1)
		
		AddHeaderOption("Nabee T")
		Craft_T = AddTextOption("Nabee T", "(Invisible)")
		Craft_PureLight[3] = AddToggleOption(s_Widelight_0 + s_CraftPurelight, b_Craft_PureLight[3])
		Craft_PlainLight[3] = AddToggleOption(s_Widelight_0 + s_CraftPlainlight, b_Craft_PlainLight[3])
		Craft_PureLight[1] = AddToggleOption(s_Facelight_0 + s_CraftPurelight, b_Craft_PureLight[1])
		Craft_PlainLight[1] = AddToggleOption(s_Facelight_0 + s_CraftPlainlight, b_Craft_PlainLight[1])
		
		AddEmptyOption()
		AddHeaderOption("Nabee Feature")
		OID_WeightClass = AddMenuOption("Nabee's Weight Class", WeightClassMenuList[i_WeightClass])
		OID_ArmorRating = AddSliderOption("Nabee's Armor Rating", ArmorRating_Var)
		
		SetCursorPosition(23)
		Credit = AddTextOption("Nabee by renn", "Version " + "4.23")
		
	;==========================================================================
	elseif a_page == Pages[2] ;Nabee Management
	
		GotoState("NabeeETCState")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		
		AddHeaderOption("Nabee - Hotkey Option")
		NabeeHotkeyEnable = AddToggleOption("Nabee Hotkey Enable", b_NabeeHotkeyEnable)
		if b_NabeeHotkeyEnable
			NabeeCycleHotkeyOID = AddKeyMapOption("Nabee Cycle Hotkey", NabeeKey.NabeeCycleHotkey, OPTION_FLAG_WITH_UNMAP)
			NabeeHotkeyOID = AddKeyMapOption("Nabee Light Hotkey", NabeeKey.NabeeHotkey, OPTION_FLAG_WITH_UNMAP)
		else
			NabeeCycleHotkeyOID = AddKeyMapOption("Nabee Cycle Hotkey", NabeeKey.NabeeCycleHotkey, 1)
			NabeeHotkeyOID = AddKeyMapOption("Nabee Light Hotkey", NabeeKey.NabeeHotkey, 1)
		endif
		AddEmptyOption()
		
		AddHeaderOption("ETC Option")
		ReactionTime = AddSliderOption("Nabee's Reaction Time", _NabeeReactionTime.GetValue(), "{2} second")
		Daytime_0 = AddSliderOption("Daytime: Start", _7.GetValue(), "{2} o'clock")
		Daytime_1 = AddSliderOption("Daytime: Finish", _19.GetValue(), "{2} o'clock")
		InventorySpell =  AddToggleOption("Add Hidden Inventory Spell", b_InventorySpell)
		ShowLocation = AddToggleOption("Show Location of Nabee NPC", b_ShowLocation)
		if i_DebugMSG == 0
			DebugMSG = AddTextOption("Show Messages", "Debug 0")
		elseif i_DebugMSG == 2
			DebugMSG = AddTextOption("Show Messages", "Debug 2")
		else
			DebugMSG = AddTextOption("Show Messages", "Debug 1")
		endif
		
		SetCursorPosition(1)
		
		AddHeaderOption("Stealth Option: Strength")
		SneakValue_ST = AddSliderOption("Sneaking: " + "Nabee ST", SneakValue_ST_Var, "{0}%")
		SneakValue_RT = AddSliderOption("Sneaking: " + "Nabee RT", SneakValue_RT_Var, "{0}%")
		SneakValue_FF = AddSliderOption("Sneaking: " + "Nabee FF", SneakValue_FF_Var, "{0}%")
		SneakValue_Dungeon = AddSliderOption("Not Sneaking: Dungeon Area", SneakValue_Dungeon_Var, "{0}%")
		SneakValue_Night = AddSliderOption("Not Sneaking: During Night", SneakValue_Night_Var, "{0}%")
		AddEmptyOption()
		
		; FISS
		FISSInterface fiss = FISSFactory.getFISS() ;Check FISS
		int fissflag = OPTION_FLAG_NONE
		int fissloadflag = OPTION_FLAG_NONE
		;string fisscheck
		if !fiss
			fissflag = OPTION_FLAG_DISABLED
			fissloadflag = OPTION_FLAG_DISABLED
		;	fisscheck = "FISS must be installed to use this."
		else
			if !CheckFISS()
				fissloadflag = OPTION_FLAG_DISABLED
			endif
		;	fisscheck = ""
		endif
		AddHeaderOption("FISS User Settings",fissflag)
		saveFISS_OID = AddTextOption("Save Current User Settings", "Do it", fissflag)
		loadFISS_OID = AddTextOption("Load Custom User Settings", "Do it", fissloadflag)
		loadFISSDwelling_OID = AddToggleOption("Load Dwellings List", b_loadFISSDwelling)
		;AddTextOption(fisscheck,"",OPTION_FLAG_DISABLED)
		ResetAll = AddTextOption("", "Reset")		
		
	;==========================================================================
	; NPC List
	elseif a_page == Pages[4] || a_page == Pages[5] || a_page == Pages[6]
	
		GotoState("NabeeNPCState")
		SetCursorFillMode(LEFT_TO_RIGHT)
		SetCursorPosition(0)
		
		int i
		int p
		int ii
		int ix = 0
		if a_page == Pages[4]
			ii = 0
			p = 10
		elseif a_page == Pages[5]
			ii = 10 + ix
			p = 20
		elseif a_page == Pages[6]
			ii = 20 + ix
			p = 30
		endif
		string s_NPCNumber
		string s_NPCFollower
		string s_NPCEquip
		string s_NPCNabeeCount
		
		AddHeaderOption("Nabee NPC: Total " + _rennNabeeFLST_NPCs.GetSize() + "  (" + (NabeeLimit - _rennNabeeFLST_NPCs.GetSize()) + " slot" + ")")
		AddHeaderOption("Nabee NPC: Status")
		;NPC_X[NabeeLimit] = AddTextOption("Click to unregister.", "")
		;NPC_T[NabeeLimit] = AddTextOption("Click to get back.", "")
		NPC_X[NabeeLimit] = AddMenuOption("", "[List Management]")
		NPC_T[NabeeLimit] = AddTextOption("Nabee NPCs Help", "")
		
		i = ii
		While i < p + ix && i < _rennNabeeFLST_NPCs.GetSize()
			NPC = _rennNabeeFLST_NPCs.GetAt(i) as Actor
			if NPC == none
				ix += 1
			else
				if NPC.isDead() || NPC.IsDisabled()
					NabeeRemoveNPC()
				else
					;================= follower or not
					if NPC.IsInFaction(CurrentFollowerFaction) || NPC.IsPlayerTeammate()
						s_NPCFollower = "(Follower)"
					else
						s_NPCFollower = ""
					endif
					;================= Equipped or not
					int i_Count = NPC.GetItemCount(_rennNabeeFLST_Armors)
					if i_Count == 0
						i_NPCNabee[i] = 0
						s_NPCEquip = "(Unequipped)"
						if b_ShowLocation
							s_NPCEquip = "(X)"
						endif
					else
						;if NPC.IsEquipped(_rennNabeeFLST_Armors)
						if _rennNabeeFLST_Armors.HasForm(NPC.GetWornForm(0x80000000) as Armor)
							s_NPCEquip = "(Equipped)"
							i_NPCNabee[i] = 2
							if b_ShowLocation
								s_NPCEquip = "(O)"
							endif
						else
							s_NPCEquip = "(Unequipped)"
							i_NPCNabee[i] = 1
							if b_ShowLocation
								s_NPCEquip = "(X)"
							endif
						endif
					endif
					s_NPCNumber = "{" + (i - ix + 1) as string + "}"
					if b_ShowLocation
						s_NPCNabeeCount = "[" + "(" + i_Count as string + "s) " + "]"
						NPC_X[i] = AddToggleOption(s_NPCNumber + NPC.GetLeveledActorBase().GetName() + s_NPCFollower, b_NPC_X[i])
						NPC_T[i] = AddTextOption(s_NPCNabeeCount + NPC.GetCurrentLocation().GetName(), s_NPCEquip)
					else
						s_NPCNabeeCount = "Nabee: " + i_Count as string + " (s)"
						NPC_X[i] = AddToggleOption(NPC.GetLeveledActorBase().GetName(), b_NPC_X[i])
						NPC_T[i] = AddTextOption(s_NPCNumber + s_NPCEquip + s_NPCFollower, s_NPCNabeeCount)
					endif
				endif
			endif
			i += 1
		endWhile
		if ix > 0
			b_ArrangeNPC = true
		else
			b_ArrangeNPC = false
		endif
	
	;==========================================================================
	; Dwelling List
	elseif a_page == Pages[12] || a_page == Pages[13]
	
		GotoState("NabeeDwellingState")
		SetCursorFillMode(LEFT_TO_RIGHT)
		SetCursorPosition(0)
		
		int i
		int p
		int ii
		int ix = 0
		if a_page == Pages[12]
			ii = 0
			p = 30
		elseif a_page == Pages[13]
			ii = 30 + ix
			p = 60
		endif
		string s_CurrentLocationDwelling
		string s_DwellingNumber
		int flagDwelling = 0
		CurrentLocation = PlayerRef.GetCurrentLocation() as Location
		
		if _rennNabeeFLST_Dwelling.GetSize() < DwellingXLimit
			if PlayerRef.IsInInterior()
				if HasCurrentLocation()
					s_CurrentLocationDwelling = "[Registered]"
					i_Dwelling_ = 1
				else
					s_CurrentLocationDwelling = "[Register]"
					if XHasCurrentLocation()
						if !HasKeyWordDwelling()
							i_Dwelling_ = 10
						else
							i_Dwelling_ = 11
						endif
					elseif !HasKeyWordDwelling()
						i_Dwelling_ = 12
					else
						s_CurrentLocationDwelling = "[X]"
						i_Dwelling_ = 0
						flagDwelling = 1
					endif
				endif
			else
				s_CurrentLocationDwelling = "[X]"
				i_Dwelling_ = 0
				flagDwelling = 1
			endif
		else
			s_CurrentLocationDwelling = "[Fulled]"
			i_Dwelling_ = 0
			flagDwelling = 1
		endif
		AddHeaderOption("Nabee Dwelling: Total " + _rennNabeeFLST_Dwelling.GetSize() + "  (" + (DwellingLimit - _rennNabeeFLST_Dwelling.GetSize()) + " slot" + ")")
		AddHeaderOption("Current Location: " + PlayerRef.GetCurrentLocation().GetName() + "                                                                                      ")
		Dwelling_[DwellingLimit + 3] = AddMenuOption("", "[Reset List]")
		Dwelling_[DwellingLimit + 2] = AddTextOption("", s_CurrentLocationDwelling, flagDwelling)
		Dwelling_[DwellingLimit + 1] = AddTextOption("", "[Unregister Selected]")
		AddEmptyOption()
		
		i = ii
		While i < p + ix && i < _rennNabeeFLST_Dwelling.GetSize()
			Dwelling = _rennNabeeFLST_Dwelling.GetAt(i) as Location
			if Dwelling == none
				ix += 1
			else
				s_DwellingNumber = "{" + (i - ix + 1) as string + "}"
				Dwelling_[i] = AddToggleOption(s_DwellingNumber + Dwelling.GetName(), b_Dwelling_[i])
			endif
			i += 1
		endWhile
		if ix > 0
			b_ArrangeDwelling = true
		else
			b_ArrangeDwelling = false
		endif
		
	;==========================================================================
	; DwellingX List
	elseif a_page == Pages[8] || a_page == Pages[9] || a_page == Pages[10]
	
		GotoState("NabeeDwellingState")
		SetCursorFillMode(LEFT_TO_RIGHT)
		SetCursorPosition(0)
		
		int i
		int p
		int ii
		int ix = 0
		if a_page == Pages[8]
			ii = 0
			p = 30
		elseif a_page == Pages[9]
			ii = 30 + ix
			p = 60
		elseif a_page == Pages[10]
			ii = 60 + ix
			p = 90
		endif
		string s_CurrentLocationDwelling
		string s_DwellingNumber
		string s_DLC
		int flagDwelling = 0
		CurrentLocation = PlayerRef.GetCurrentLocation() as Location
		
		;if PlayerRef.IsInInterior()
		if _rennNabeeFLST_DwellingX.GetSize() < DwellingXLimit
			if XHasCurrentLocation()
				s_CurrentLocationDwelling = "[Registered]"
				i_DwellingX_ = 1
			else
				s_CurrentLocationDwelling = "[Register]"
				if HasCurrentLocation()
					i_DwellingX_ = 11
				else
					if HasKeyWordDwelling()
						i_DwellingX_ = 10
					elseif !HasKeyWordDungeon()
						i_DwellingX_ = 12
					else
						s_CurrentLocationDwelling = "[X]"
						i_DwellingX_ = 0
						flagDwelling = 1
					endif
				endif
			endif
		else
			s_CurrentLocationDwelling = "[Fulled]"
			i_DwellingX_ = 0
			flagDwelling = 1
		endif
		if i_DG == 0
			s_DLC = "DG (X) "
		else
			s_DLC = "DG (O) "
		endif
		
		AddHeaderOption("Nabee DwellingX: Total " + _rennNabeeFLST_DwellingX.GetSize() + "  (" + (DwellingXLimit - _rennNabeeFLST_DwellingX.GetSize()) + " slot" + ")")
		AddHeaderOption("Current Location: " + PlayerRef.GetCurrentLocation().GetName() + "                                                                                      ")
		DwellingX_[DwellingXLimit + 3] = AddMenuOption(s_DLC, "[Reset List]")
		DwellingX_[DwellingXLimit + 2] = AddTextOption("", s_CurrentLocationDwelling, flagDwelling)
		DwellingX_[DwellingXLimit + 1] = AddTextOption("", "[Unregister Selected]")
		AddEmptyOption()
		
		i = ii
		While i < p + ix && i < _rennNabeeFLST_DwellingX.GetSize()
			Dwelling = _rennNabeeFLST_DwellingX.GetAt(i) as Location
			if Dwelling == none
				ix += 1
			else
				s_DwellingNumber = "{" + (i - ix + 1) as string + "}"
				DwellingX_[i] = AddToggleOption(s_DwellingNumber + Dwelling.GetName(), b_DwellingX_[i])
			endif
			i += 1
		endWhile
		if ix > 0
			b_ArrangeDwellingX = true
		else
			b_ArrangeDwellingX = false
		endif
		
	endif
	endif
endEvent

event OnOptionSelect(int option)
	if option == Credit
		SetTextOptionValue(option, "Activating...")
		ReadPages()
		b_Init = true
		ForcePageReset()
	endif
endEvent


;==========================================================================================================
; Nabee Settings Page
;==========================================================================================================

state NabeeSettingState

event OnOptionSelect(int option)
	int i	
	if option == Radius_FF[_C_]
		ResetRadiusFF()
		i = 0
		While i < _C_ - 1
			SetSliderOptionValue(Radius_FF[i], Radius_FF_Var[i])
			if i == 0
				if HouseIndex_ST == 1
					SetSliderOptionValue(Radius_ST[1], Radius_FF_Var[i])
				elseif HouseIndex_RT == 1
					SetSliderOptionValue(Radius_RT[1], Radius_FF_Var[i])
				endif
			endif
			i += 1
		endWhile
		b_ApplyNabeeRadiusFF = true
	elseif option == Radius_ST[_C_]
		ResetRadiusST()
		i = 0
		While i < _C_
			if !(i == 1 && HouseIndex_ST == 1) && !(i == 4 && SneakIndex_ST == 1)
				SetSliderOptionValue(Radius_ST[i], Radius_ST_Var[i])
			endif
			i += 1
		endWhile
		b_ApplyNabeeRadiusST = true
	elseif option == Radius_RT[_C_]
		ResetRadiusRT()
		i = 0
		While i < _C_
			if !(i == 1 && HouseIndex_RT == 1) && !(i == 4 && SneakIndex_RT == 1)		
				SetSliderOptionValue(Radius_RT[i], Radius_RT_Var[i])
			endif
			i += 1
		endWhile
		b_ApplyNabeeRadiusRT = true
	endif
endEvent

event OnOptionMenuOpen(int option)
	if (option == House_ST)
		SetMenuDialogOptions(HouseList)
		SetMenuDialogStartIndex(HouseIndex_ST)
		SetMenuDialogDefaultIndex(1)
	elseif (option == House_RT)
		SetMenuDialogOptions(HouseList)
		SetMenuDialogStartIndex(HouseIndex_RT)
		SetMenuDialogDefaultIndex(1)
	elseif (option == Sneak_ST)
		SetMenuDialogOptions(SneakList)
		SetMenuDialogStartIndex(SneakIndex_ST)
		SetMenuDialogDefaultIndex(2)
	elseif (option == Sneak_RT)
		SetMenuDialogOptions(SneakList)
		SetMenuDialogStartIndex(SneakIndex_RT)
		SetMenuDialogDefaultIndex(2)
	elseif (option == Sneak_FF)
		SetMenuDialogOptions(SneakList_FF)
		SetMenuDialogStartIndex(SneakIndex_FF)
		SetMenuDialogDefaultIndex(1)
	endif
	if (option == Brightness_FF[_C_])
		SetMenuDialogOptions(BrightnessListGroup)
		SetMenuDialogStartIndex(BrightnessIndex_FF[_C_])
		SetMenuDialogDefaultIndex(0)
	elseif (option == Brightness_ST[_C_])
		SetMenuDialogOptions(BrightnessListGroup)
		SetMenuDialogStartIndex(BrightnessIndex_ST[_C_])
		SetMenuDialogDefaultIndex(0)
	elseif (option == Brightness_RT[_C_])
		SetMenuDialogOptions(BrightnessListGroup)
		SetMenuDialogStartIndex(BrightnessIndex_RT[_C_])
		SetMenuDialogDefaultIndex(0)
	endif
	int i
	i = 0
	While i < _C_ - 1
		if (option == Brightness_FF[i])
			SetMenuDialogOptions(BrightnessList)
			SetMenuDialogStartIndex(BrightnessIndex_FF[i])
			SetMenuDialogDefaultIndex(0)
		endif
		i += 1
	endWhile
	i = 0
	While i < _C_
		if (option == Brightness_ST[i])
			if i == 1 && HouseIndex_ST == 1
				SetMenuDialogStartIndex(BrightnessIndex_FF[0])
			elseif i == 4 && SneakIndex_ST == 1
				SetMenuDialogStartIndex(BrightnessIndex_FF[i])
			else
				SetMenuDialogStartIndex(BrightnessIndex_ST[i])
			endif
			SetMenuDialogOptions(BrightnessList)
			SetMenuDialogDefaultIndex(0)
		elseif (option == Brightness_RT[i])
			if i == 1 && HouseIndex_RT == 1
				SetMenuDialogStartIndex(BrightnessIndex_FF[0])
			elseif i == 4 && SneakIndex_RT == 1
				SetMenuDialogStartIndex(BrightnessIndex_FF[i])
			else
				SetMenuDialogStartIndex(BrightnessIndex_RT[i])
			endif
			SetMenuDialogOptions(BrightnessList)
			SetMenuDialogDefaultIndex(0)
		endif			
		i += 1
	endWhile
endEvent

event OnOptionMenuAccept(int option, int index)
	if (option == House_ST)
		HouseIndex_ST = index
		SetMenuOptionValue(option, HouseList[HouseIndex_ST])
		ForcePageReset()
		b_ApplyNabeeEnchST = true
	elseif (option == House_RT)
		HouseIndex_RT = index
		SetMenuOptionValue(option, HouseList[HouseIndex_RT])
		ForcePageReset()
		b_ApplyNabeeEnchRT = true
	elseif (option == Sneak_ST)
		SneakIndex_ST = index
		SetMenuOptionValue(option, SneakList[SneakIndex_ST])
		ForcePageReset()
		b_ApplyNabeeEnchST = true
	elseif (option == Sneak_RT)
		SneakIndex_RT = index
		SetMenuOptionValue(option, SneakList[SneakIndex_RT])
		ForcePageReset()
		b_ApplyNabeeEnchRT = true
	elseif (option == Sneak_FF)
		SneakIndex_FF = index
		SetMenuOptionValue(option, SneakList_FF[SneakIndex_FF])
		ForcePageReset()
		b_ApplyNabeeEnchFF = true
	endif
	string s_font_0		= " (( "
	string s_font_1		= " )) "
	int i
	if (option == Brightness_FF[_C_])
		BrightnessIndex_FF[_C_] = index
		SetMenuOptionValue(option, s_font_0 + BrightnessListGroup[BrightnessIndex_FF[_C_]] + s_font_1)
		if BrightnessIndex_FF[_C_] != _B_
			i = 0
			While i < _C_ + 1
				BrightnessIndex_FF[i] = index
				SetMenuOptionValue(Brightness_FF[i], BrightnessList[BrightnessIndex_FF[i]])
				i += 1
			endWhile
		endif
		b_ApplyNabeeSpellFF = true
	elseif (option == Brightness_ST[_C_])
		BrightnessIndex_ST[_C_] = index
		SetMenuOptionValue(option, s_font_0 + BrightnessListGroup[BrightnessIndex_ST[_C_]] + s_font_1)
		if BrightnessIndex_ST[_C_] != _B_
			i = 0
			While i < _C_
				BrightnessIndex_ST[i] = index
				SetMenuOptionValue(Brightness_ST[i], BrightnessList[BrightnessIndex_ST[i]])
				i += 1
			endWhile
		endif
		b_ApplyNabeeSpellST = true
	elseif (option == Brightness_RT[_C_])
		BrightnessIndex_RT[_C_] = index
		SetMenuOptionValue(option, s_font_0 + BrightnessListGroup[BrightnessIndex_RT[_C_]] + s_font_1)
		if BrightnessIndex_RT[_C_] != _B_
			i = 0
			While i < _C_
				BrightnessIndex_RT[i] = index
				SetMenuOptionValue(Brightness_RT[i], BrightnessList[BrightnessIndex_RT[i]])
				i += 1
			endWhile
		endif
		b_ApplyNabeeSpellRT = true
	endif
	i = 0
	While i < _C_ - 1
		if (option == Brightness_FF[i])
			BrightnessIndex_FF[i] = index
			SetMenuOptionValue(option, BrightnessList[BrightnessIndex_FF[i]])
			if i == 0
				if HouseIndex_ST == 1
					SetMenuOptionValue(Brightness_ST[1], BrightnessList[BrightnessIndex_FF[i]])
				endif
				if HouseIndex_RT == 1
					SetMenuOptionValue(Brightness_RT[1], BrightnessList[BrightnessIndex_FF[i]])
				endif				
			endif
			if BrightnessIndex_FF[_C_] != index
				BrightnessIndex_FF[_C_] = _B_
				SetMenuOptionValue(Brightness_FF[_C_], s_font_0 + BrightnessListGroup[_B_] + s_font_1)
			endif
			b_ApplyNabeeSpellFF = true
		endif
		i += 1
	endWhile
	i = 0
	While i < _C_
		if (option == Brightness_ST[i])
			if (i == 1 && HouseIndex_ST == 1) || (i == 4 && SneakIndex_ST == 1)
				if i == 1 && HouseIndex_ST == 1
					BrightnessIndex_FF[0] = index
					SetMenuOptionValue(option, BrightnessList[BrightnessIndex_FF[0]])
					SetMenuOptionValue(Brightness_FF[i], BrightnessList[BrightnessIndex_FF[0]])
					if HouseIndex_RT == 1
						SetMenuOptionValue(Brightness_RT[i], BrightnessList[BrightnessIndex_FF[0]])
					endif
				elseif i == 4 && SneakIndex_ST == 1
					BrightnessIndex_FF[i] = index
					SetMenuOptionValue(option, BrightnessList[BrightnessIndex_FF[i]])
					if SneakIndex_RT == 1
						SetMenuOptionValue(Brightness_RT[i], BrightnessList[BrightnessIndex_FF[i]])
					endif
				endif				
				if BrightnessIndex_FF[_C_] != index
					BrightnessIndex_FF[_C_] = _B_
					SetMenuOptionValue(Brightness_FF[_C_], s_font_0 + BrightnessListGroup[_B_] + s_font_1)
				endif
				b_ApplyNabeeSpellFF = true
			else
				BrightnessIndex_ST[i] = index
				SetMenuOptionValue(option, BrightnessList[BrightnessIndex_ST[i]])
				if BrightnessIndex_ST[_C_] != index
					BrightnessIndex_ST[_C_] = _B_
					SetMenuOptionValue(Brightness_ST[_C_], s_font_0 + BrightnessListGroup[_B_] + s_font_1)
				endif
				b_ApplyNabeeSpellST = true
			endif
		elseif (option == Brightness_RT[i])
			if (i == 1 && HouseIndex_RT == 1) || (i == 4 && SneakIndex_RT == 1)
				if i == 1 && HouseIndex_RT == 1
					BrightnessIndex_FF[0] = index
					SetMenuOptionValue(option, BrightnessList[BrightnessIndex_FF[0]])
					SetMenuOptionValue(Brightness_FF[i], BrightnessList[BrightnessIndex_FF[0]])
					if HouseIndex_ST == 1
						SetMenuOptionValue(Brightness_ST[i], BrightnessList[BrightnessIndex_FF[0]])
					endif
				elseif i == 4 && SneakIndex_RT == 1
					BrightnessIndex_FF[i] = index
					SetMenuOptionValue(option, BrightnessList[BrightnessIndex_FF[i]])
					if SneakIndex_ST == 1
						SetMenuOptionValue(Brightness_ST[i], BrightnessList[BrightnessIndex_FF[i]])
					endif
				endif				
				if BrightnessIndex_FF[_C_] != index
					BrightnessIndex_FF[_C_] = _B_
					SetMenuOptionValue(Brightness_FF[_C_], s_font_0 + BrightnessListGroup[_B_] + s_font_1)
				endif
				b_ApplyNabeeSpellFF = true
			else
				BrightnessIndex_RT[i] = index
				SetMenuOptionValue(option, BrightnessList[BrightnessIndex_RT[i]])
				if BrightnessIndex_RT[_C_] != index
					BrightnessIndex_RT[_C_] = _B_
					SetMenuOptionValue(Brightness_RT[_C_], s_font_0 + BrightnessListGroup[_B_] + s_font_1)
				endif
				b_ApplyNabeeSpellRT = true
			endif
		endif
		i += 1
	endWhile
endEvent

event OnOptionSliderOpen(int option)
	int Radius_Var_Min = 24
	int[] Radius_Var_Max
	int[] Radius_Var_MaxFF
	int[] Radius_Var_Default
	int Radius_Var_DefaultFF = 80
	Radius_Var_Max			= new int[5]
	Radius_Var_Max[0]		= 2000
	Radius_Var_Max[1]		= 1600
	Radius_Var_Max[2]		= 2000
	Radius_Var_Max[3]		= 3000
	Radius_Var_Max[4]		= 2000
	Radius_Var_MaxFF		= new int[5]
	Radius_Var_MaxFF[0]		= 1600
	Radius_Var_MaxFF[1]		= 160
	Radius_Var_MaxFF[2]		= 1600
	Radius_Var_MaxFF[3]		= 1600
	Radius_Var_MaxFF[4]		= 160
	Radius_Var_Default		= new int[5]
	Radius_Var_Default[0]	= 600
	Radius_Var_Default[1]	= 320
	Radius_Var_Default[2]	= 600
	Radius_Var_Default[3]	= 1000
	Radius_Var_Default[4]	= 600
	int i
	i = 0
	While i < _C_ - 1
		if option == Radius_FF[i]
			SetSliderDialogStartValue(Radius_FF_Var[i])
			SetSliderDialogDefaultValue(Radius_Var_DefaultFF)
			SetSliderDialogRange(Radius_Var_Min, Radius_Var_MaxFF[i])
			SetSliderDialoginterval(2)
		endif
		i += 1
	endWhile
	i = 0
	While i < _C_
		if option == Radius_ST[i]
			;--------------------------------- Dwelling Facelight
			if i == 1 && HouseIndex_ST == 1
				SetSliderDialogStartValue(Radius_FF_Var[0])
				SetSliderDialogDefaultValue(Radius_Var_DefaultFF)
				SetSliderDialogRange(Radius_Var_Min, Radius_Var_MaxFF[0])
				SetSliderDialoginterval(2)
			;--------------------------------- Sneaking Facelight
			elseif i == 4 && SneakIndex_ST == 1
				SetSliderDialogStartValue(Radius_FF_Var[i])
				SetSliderDialogDefaultValue(Radius_Var_DefaultFF)
				SetSliderDialogRange(Radius_Var_Min, Radius_Var_MaxFF[i])
				SetSliderDialoginterval(2)
			else
				SetSliderDialogStartValue(Radius_ST_Var[i])
				SetSliderDialogDefaultValue(Radius_Var_Default[i])
				SetSliderDialogRange(Radius_Var_Min, Radius_Var_Max[i])
				SetSliderDialoginterval(4)
			endif
		elseif option == Radius_RT[i]
			;--------------------------------- Dwelling Facelight
			if i == 1 && HouseIndex_RT == 1
				SetSliderDialogStartValue(Radius_FF_Var[0])
				SetSliderDialogDefaultValue(Radius_Var_DefaultFF)
				SetSliderDialogRange(Radius_Var_Min, Radius_Var_MaxFF[0])
				SetSliderDialoginterval(2)
			;--------------------------------- Sneaking Facelight
			elseif i == 4 && SneakIndex_RT == 1
				SetSliderDialogStartValue(Radius_FF_Var[i])
				SetSliderDialogDefaultValue(Radius_Var_DefaultFF)
				SetSliderDialogRange(Radius_Var_Min, Radius_Var_MaxFF[i])
				SetSliderDialoginterval(2)
			else
				SetSliderDialogStartValue(Radius_RT_Var[i])
				SetSliderDialogDefaultValue(Radius_Var_Default[i])
				SetSliderDialogRange(Radius_Var_Min, Radius_Var_Max[i])
				SetSliderDialoginterval(4)
			endif
		endif
		i += 1
	endWhile
endEvent

event OnOptionSliderAccept(int option, float value)
	int i
	i = 0
	While i < _C_ - 1
		if option == Radius_FF[i]
			Radius_FF_Var[i] = value as int
			SetSliderOptionValue(Radius_FF[i], Radius_FF_Var[i])
			if i == 0
				if HouseIndex_ST == 1
					SetMenuOptionValue(Radius_ST[1], Radius_FF_Var[i])
				endif
				if HouseIndex_RT == 1
					SetMenuOptionValue(Radius_RT[1], Radius_FF_Var[i])
				endif				
			endif
			Radius_FF_Var[_C_] = 1
			b_ApplyNabeeRadiusFF = true
		endif
		i += 1
	endWhile
	i = 0
	while i < _C_
		if option == Radius_ST[i]
			;--------------------------------- Dwelling Facelight
			if i == 1 && HouseIndex_ST == 1
				Radius_FF_Var[0] = value as int
				SetSliderOptionValue(Radius_ST[i], Radius_FF_Var[0])
				SetSliderOptionValue(Radius_FF[0], Radius_FF_Var[0])
				if HouseIndex_RT == 1
					SetSliderOptionValue(Radius_RT[i], Radius_FF_Var[0])
				endif
				b_ApplyNabeeRadiusFF = true
			;--------------------------------- Sneaking Facelight
			elseif i == 4 && SneakIndex_ST == 1
				Radius_FF_Var[i] = value as int
				SetSliderOptionValue(Radius_ST[i], Radius_FF_Var[i])
				if SneakIndex_RT == 1
					SetSliderOptionValue(Radius_RT[i], Radius_FF_Var[i])
				endif
				b_ApplyNabeeRadiusFF = true
			else
				Radius_ST_Var[i] = value as int
				SetSliderOptionValue(Radius_ST[i], Radius_ST_Var[i])
				b_ApplyNabeeRadiusST = true
			endif
			Radius_ST_Var[_C_] = 1
		elseif option == Radius_RT[i]
			;--------------------------------- Dwelling Facelight
			if i == 1 && HouseIndex_RT == 1
				Radius_FF_Var[0] = value as int
				SetSliderOptionValue(Radius_RT[i], Radius_FF_Var[0])
				SetSliderOptionValue(Radius_FF[0], Radius_FF_Var[0])
				if HouseIndex_ST == 1
					SetSliderOptionValue(Radius_ST[i], Radius_FF_Var[0])
				endif
				b_ApplyNabeeRadiusFF = true
			;--------------------------------- Sneaking Facelight
			elseif i == 4 && SneakIndex_RT == 1
				Radius_FF_Var[i] = value as int
				SetSliderOptionValue(Radius_RT[i], Radius_FF_Var[i])
				if SneakIndex_ST == 1
					SetSliderOptionValue(Radius_ST[i], Radius_FF_Var[i])
				endif
				b_ApplyNabeeRadiusFF = true
			else
				Radius_RT_Var[i] = value as int
				SetSliderOptionValue(Radius_RT[i], Radius_RT_Var[i])
				b_ApplyNabeeRadiusRT = true
			endif
			Radius_RT_Var[_C_] = 1
		endif
		i += 1
	endWhile
endEvent

event OnOptionHighlight(int option)
	if (option == BrightnessHelp)
		SetInfoText("BrightnessHelp Info.")
	elseif (option == House_ST || option == House_RT)
		SetInfoText("House Info.")
	elseif (option == House_FF)
		SetInfoText("House FF Info.")
	elseif (option == Sneak_ST || option == Sneak_RT || option == Sneak_FF)
		SetInfoText("Sneak Info.")
	elseif (option == Radius_ST[_C_] || option == Radius_RT[_C_] || option == Radius_FF[_C_])
		SetInfoText("Radius Reset Info.")
	elseif (option == Radius_ST[0] || option == Radius_RT[0] || option == Radius_FF[0])
		SetInfoText("Radius: General Info.")
	elseif (option == Radius_ST[1] || option == Radius_RT[1])
		SetInfoText("Radius: Dwelling Info.")
	elseif (option == Radius_ST[2] || option == Radius_RT[2])
		SetInfoText("Radius: DwellingX Info.")
	elseif (option == Radius_ST[3] || option == Radius_RT[3])
		SetInfoText("Radius: Night Info.")
	elseif (option == Radius_ST[4] || option == Radius_RT[4])
		SetInfoText("Radius: Sneaking Info.")
	elseif (option == Radius_FF[1])
		SetInfoText("Radius: Clear Day Facelight Info.")
	elseif (option == Radius_FF[2])
		SetInfoText("Radius: Cloudy Day Facelight Info.")	
	elseif (option == Radius_FF[3])
		SetInfoText("Radius: Night Facelight Info.")
	elseif (option == Brightness_ST[_C_] || option == Brightness_RT[_C_] || option == Brightness_FF[_C_])
		SetInfoText("Brightness Info.")
	elseif (option == Brightness_ST[0] || option == Brightness_RT[0] || option == Brightness_FF[0])
		SetInfoText("Brightness Info.")
	elseif (option == Brightness_ST[1])
		if HouseIndex_ST == 1
			SetInfoText("Brightness: Dwelling Facelight Info.")
		else			
			SetInfoText("Brightness: Dwelling Info.")
		endif
	elseif (option == Brightness_RT[1])
		if HouseIndex_RT == 1
			SetInfoText("Brightness: Dwelling Facelight Info.")
		else			
			SetInfoText("Brightness: Dwelling Info.")
		endif
	elseif (option == Brightness_ST[2] || option == Brightness_RT[2])
		SetInfoText("Brightness: DwellingX Info.")
	elseif (option == Brightness_ST[3] || option == Brightness_RT[3])
		SetInfoText("Brightness: Night Info.")
	elseif (option == Brightness_ST[4])
		if SneakIndex_ST == 1		
			SetInfoText("Brightness: Sneaking Facelight Info.")
		else			
			SetInfoText("Brightness: Sneaking Info.")
		endif
	elseif (option == Brightness_RT[4])
		if SneakIndex_RT == 1		
			SetInfoText("Brightness: Sneaking Facelight Info.")
		else			
			SetInfoText("Brightness: Sneaking Info.")
		endif
	elseif (option == Brightness_FF[1])
		SetInfoText("Brightness: Clear Day Facelight Info.")
	elseif (option == Brightness_FF[2])
		SetInfoText("Brightness: Cloudy Day Facelight Info.")
	elseif (option == Brightness_FF[3])
		SetInfoText("Brightness: Night Facelight Info.")
	endif
endEvent

endState

function ResetRadiusST()
	Radius_ST_Var[0]		= 600
	Radius_ST_Var[1]		= 320
	Radius_ST_Var[2]		= 600
	Radius_ST_Var[3]		= 1000
	Radius_ST_Var[4]		= 600
	Radius_ST_Var[_C_]		= 0
endFunction

function ResetRadiusRT()
	Radius_RT_Var[0]		= 600
	Radius_RT_Var[1]		= 320
	Radius_RT_Var[2]		= 600
	Radius_RT_Var[3]		= 1000
	Radius_RT_Var[4]		= 600
	Radius_RT_Var[_C_]		= 0
endFunction

function ResetRadiusFF()
	int i = 0
	While i < _C_
		Radius_FF_Var[i]	= 80
		i += 1
	endWhile
	Radius_FF_Var[_C_]		= 0
endFunction

;==========================================================================================================
; ETC Page
;==========================================================================================================

state NabeeETCState

event OnOptionDefault(int option)
	if option == NabeeHotkeyOID
		NabeeKey.NabeeHotkey = -1
		SetKeymapOptionValue(NabeeHotkeyOID, NabeeKey.NabeeHotkey)
	elseif option == NabeeCycleHotkeyOID
		NabeeKey.NabeeCycleHotkey = -1
		SetKeymapOptionValue(NabeeCycleHotkeyOID, NabeeKey.NabeeCycleHotkey)
	endif
endEvent

event OnOptionKeyMapChange(int option, int newKeyCode, string conflictControl, string conflictName)
	if option == NabeeHotkeyOID
		bool Continue = true
		if (conflictControl != "")
			string NabeeHotkeyMsg
			if (conflictName != "")
				NabeeHotkeyMsg = "This key is already mapped to:" + "\n\"" + conflictControl + "\"\n(" + conflictName + ")\n" + "Are you sure you want to continue?"
			else
				NabeeHotkeyMsg = "This key is already mapped to:" + "\n\"" + conflictControl + "\"\n" + "Are you sure you want to continue?"
			endif
			Continue = ShowMessage(NabeeHotkeyMsg, true, "$Yes", "$No")
		endif
		if Continue
			NabeeKey.NabeeHotkey = newKeyCode
			SetKeymapOptionValue(NabeeHotkeyOID, NabeeKey.NabeeHotkey)
			ForcePageReset()
		endif
	elseif option == NabeeCycleHotkeyOID
		bool Continue = true
		if (conflictControl != "")
			string NabeeCycleHotkeyMsg
			if (conflictName != "")
				NabeeCycleHotkeyMsg = "This key is already mapped to:" + "\n\"" + conflictControl + "\"\n(" + conflictName + ")\n" + "Are you sure you want to continue?"
			else
				NabeeCycleHotkeyMsg = "This key is already mapped to:" + "\n\"" + conflictControl + "\"\n" + "Are you sure you want to continue?"
			endif
			Continue = ShowMessage(NabeeCycleHotkeyMsg, true, "$Yes", "$No")
		endif
		if Continue
			NabeeKey.NabeeCycleHotkey = newKeyCode
			SetKeymapOptionValue(NabeeCycleHotkeyOID, NabeeKey.NabeeCycleHotkey)
			ForcePageReset()
		endif
	endif
endEvent

event OnOptionSelect(int option)
	if (option == NabeeHotkeyEnable)
		b_NabeeHotkeyEnable = !b_NabeeHotkeyEnable
		SetToggleOptionValue(option, b_NabeeHotkeyEnable)
		ForcePageReset()
	elseif (option == InventorySpell)
		b_InventorySpell = !b_InventorySpell
		SetToggleOptionValue(option, b_InventorySpell)		
	elseif (option == ShowLocation)
		b_ShowLocation = !b_ShowLocation
		SetToggleOptionValue(option, b_ShowLocation)	
	elseif (option == DebugMSG)
		i_DebugMSG += 1
		if i_DebugMSG == 3			
			i_DebugMSG = 0
		endif
		ForcePageReset()
	elseif (option == ResetAll)
		if ShowMessage("Do you really want to reset All current settings?", true)
			int i
			i = 0
			While i < _C_ + 1
				BrightnessIndex_ST[i]		= 0
				BrightnessIndex_RT[i]		= 0
				BrightnessIndex_FF[i]		= 0
				i += 1
			endWhile
			ResetRadiusST()
			ResetRadiusRT()
			ResetRadiusFF()
			HouseIndex_ST					= 1
			HouseIndex_RT					= 1
			SneakIndex_ST					= 2
			SneakIndex_RT					= 2
			SneakIndex_FF					= 1
			SneakValue_ST_Var				= 35.0
			SneakValue_RT_Var				= 35.0
			SneakValue_FF_Var				= 25.0
			SneakValue_Dungeon_Var			= 20.0
			SneakValue_Night_Var			= 20.0
			i = 0
			While i < 6
				b_Craft_PureLight[i]		= true
				b_Craft_PlainLight[i]		= false
				i += 1
			endWhile
			b_Craft_PureLight[5]			= false
			i_WeightClass					= 2
			ArmorRating_Var					= 0
			NabeeKey._NabeeLight.SetValue(1)
			b_NabeeHotkeyEnable				= false
			NabeeKey.NabeeHotkey			= -1
			NabeeKey.NabeeCycleHotkey		= -1
			_NabeeReactionTime.SetValue(0.3)
			_7.SetValue(7)
			_19.SetValue(19)
			b_InventorySpell				= false
			b_ShowLocation					= true
			i_DebugMSG						= 1
			ForcePageReset()
			ShowMessage("All settings reset.", false)
			ApplyAllReady()
		endif
	elseif (option == saveFISS_OID)
		string s_saveFISS
		if CheckFISS()
			s_saveFISS = "There are already settings saved.\nDo you want to overwrite them?"
		else
			s_saveFISS = "Do you want to save current configuration?"
		endif
		if ShowMessage(s_saveFISS, true)
			if SaveFISS()
				ForcePageReset()
				ShowMessage("Current configuration was saved successfully.", false)
			else
				ShowMessage("Couldn't save current configuration.", false)
			endif
		endif
	elseif (option == loadFISS_OID)
		;if CheckFISS()
			if ShowMessage("Do you really want to load the previously saved settings?\nThe current configuration will be overwritten.", true)
				if LoadFISS()
					if b_loadFISSDwelling
						ShowMessage("The configuration was loaded successfully." + "Also Dwelling Lists added.", false)
					else
						ShowMessage("The configuration was loaded successfully.", false)
					endif
				else
					ShowMessage("Couldn't load the configuration.", false)
				endif
				ForcePageReset()
				ApplyAllReady()
			endif
		;endif
	elseif (option == loadFISSDwelling_OID)
		b_loadFISSDwelling = !b_loadFISSDwelling
		SetToggleOptionValue(option, b_loadFISSDwelling)
	endif
endEvent

event OnOptionMenuOpen(int option)
	;
endEvent

event OnOptionMenuAccept(int option, int index)
	;
endEvent

event OnOptionSliderOpen(int option)
	if option == Daytime_0
        SetSliderDialogStartValue(_7.GetValue())
        SetSliderDialogDefaultValue(7.00)
        SetSliderDialogRange(0.00, 12.00)
        SetSliderDialoginterval(0.25)
	elseif option == Daytime_1
        SetSliderDialogStartValue(_19.GetValue())
        SetSliderDialogDefaultValue(19.00)
        SetSliderDialogRange(12.00, 24.00)
        SetSliderDialoginterval(0.25)
    elseif option == ReactionTime
        SetSliderDialogStartValue(_NabeeReactionTime.GetValue())
        SetSliderDialogDefaultValue(0.30)
        SetSliderDialogRange(0.10, 1.00)
        SetSliderDialoginterval(0.05)
	elseif option == SneakValue_ST
        SetSliderDialogStartValue(SneakValue_ST_Var)
        SetSliderDialogDefaultValue(35)
        SetSliderDialogRange(15, 150)
        SetSliderDialoginterval(1)
    elseif option == SneakValue_RT
        SetSliderDialogStartValue(SneakValue_RT_Var)
        SetSliderDialogDefaultValue(35)
        SetSliderDialogRange(15, 150)
        SetSliderDialoginterval(1)
    elseif option == SneakValue_FF
        SetSliderDialogStartValue(SneakValue_FF_Var)
        SetSliderDialogDefaultValue(25)
        SetSliderDialogRange(10, 150)
        SetSliderDialoginterval(1)
    elseif option == SneakValue_Dungeon
        SetSliderDialogStartValue(SneakValue_Dungeon_Var)
        SetSliderDialogDefaultValue(20)
        SetSliderDialogRange(0, 80)
        SetSliderDialoginterval(1)
    elseif option == SneakValue_Night
        SetSliderDialogStartValue(SneakValue_Night_Var)
        SetSliderDialogDefaultValue(20)
        SetSliderDialogRange(0, 80)
        SetSliderDialoginterval(1)
	endif
endEvent

event OnOptionSliderAccept(int option, float value)
    if option == Daytime_0
        _7.SetValue(value)
        SetSliderOptionValue(option, value, "{2} o'clock")
    elseif option == Daytime_1
        _19.SetValue(value)
        SetSliderOptionValue(option, value, "{2} o'clock")
    elseif option == ReactionTime
        _NabeeReactionTime.SetValue(value)
        SetSliderOptionValue(option, value, "{2} second")
    elseif option == SneakValue_ST
		SneakValue_ST_Var = value
        SetSliderOptionValue(option, value, "{0}%")
		ForcePageReset()
		b_NabeeSneakValue = true
    elseif option == SneakValue_RT
		SneakValue_RT_Var = value
        SetSliderOptionValue(option, value, "{0}%")
		ForcePageReset()
		b_NabeeSneakValue = true
    elseif option == SneakValue_FF
		SneakValue_FF_Var = value
        SetSliderOptionValue(option, value, "{0}%")
		ForcePageReset()
		b_NabeeSneakValue = true
    elseif option == SneakValue_Dungeon
		SneakValue_Dungeon_Var = value
        SetSliderOptionValue(option, value, "{0}%")
		ForcePageReset()
		b_NabeeSneakValue = true
    elseif option == SneakValue_Night
		SneakValue_Night_Var = value
        SetSliderOptionValue(option, value, "{0}%")
		ForcePageReset()
		b_NabeeSneakValue = true
	endif
endEvent

event OnOptionHighlight(int option)
	if option == NabeeHotkeyOID
		SetInfoText("Change the Nabee hotkey.")
	elseif option == NabeeCycleHotkeyOID
		SetInfoText("Change the Nabee Cycle hotkey.")
	elseif (option == SneakValue_ST || option == SneakValue_RT || option == SneakValue_FF)
		SetInfoText("SneakValue Info.")
	elseif (option == SneakValue_Dungeon)
		SetInfoText("SneakValue_Dungeon Info.")
	elseif (option == SneakValue_Night)
		SetInfoText("SneakValue_Night Info.")
	elseif (option == NabeeHotkeyEnable)
		SetInfoText("NabeeHotkeyEnable Info.")
	elseif (option == ReactionTime)
		SetInfoText("ReactionTime Info.")
	elseif (option == Daytime_0 || option == Daytime_1)
		SetInfoText("Daytime Info.")
	elseif (option == InventorySpell)
		SetInfoText("InventorySpell Info.")
	elseif (option == ShowLocation)
		SetInfoText("ShowLocation Info.")
	elseif (option == DebugMSG)
		SetInfoText("DebugMSG Info.")
	elseif (option == saveFISS_OID)
		SetInfoText("Saves the current settings for all configuration options so they can be loaded later.")
	elseif (option == loadFISS_OID)
		SetInfoText("Loads the previously saved settings for all configuration options.")
	elseif (option == loadFISSDwelling_OID)
		SetInfoText("Loads the previously saved settings including Dwelling and Non-Dwelling Lists.")
	elseif (option == Credit)
		SetInfoText("Credit Info.")
	endif
endEvent

endState

;==========================================================================================================
; Nabee Craft Page
;==========================================================================================================

state NabeeCraftState

event OnOptionSelect(int option)
	int i = 0
	While i < 6
		if (option == Craft_PureLight[i])
			b_Craft_PureLight[i] = !b_Craft_PureLight[i]
			SetToggleOptionValue(Craft_PureLight[i], b_Craft_PureLight[i])
			b_NabeeCraftValue = true
		elseif (option == Craft_PlainLight[i])
			b_Craft_PlainLight[i] = !b_Craft_PlainLight[i]
			SetToggleOptionValue(Craft_PlainLight[i], b_Craft_PlainLight[i])
			b_NabeeCraftValue = true
		endif
		i += 1
	endWhile
endEvent

event OnOptionMenuOpen(int option)
	if (option == OID_WeightClass)
		SetMenuDialogOptions(WeightClassMenuList)
		SetMenuDialogStartIndex(i_WeightClass)
		SetMenuDialogDefaultIndex(0)
	endif
endEvent

event OnOptionMenuAccept(int option, int index)
	if (option == OID_WeightClass)
		i_WeightClass = index
		SetMenuOptionValue(OID_WeightClass, WeightClassMenuList[i_WeightClass])
		ForcePageReset()
		b_ApplyNabeeClass = true
	endif
endEvent

event OnOptionSliderOpen(int option)
    if option == OID_ArmorRating
        SetSliderDialogStartValue(ArmorRating_Var)
        SetSliderDialogDefaultValue(0)
        SetSliderDialogRange(0, 50)
        SetSliderDialoginterval(1)
	endif
endEvent

event OnOptionSliderAccept(int option, float value)
    if option == OID_ArmorRating
        ArmorRating_Var = value as int
        SetSliderOptionValue(OID_ArmorRating, value)
		b_ApplyNabeeClass = true
	endif
endEvent

event OnOptionHighlight(int option)
	if (option == Craft_ST)
		SetInfoText("Craft_ST Info.")
	elseif (option == Craft_T)
		SetInfoText("Craft_T Info.")
	elseif (option == Craft_RT)
		SetInfoText("Craft_RT Info.")
	elseif (option == Craft_RR)
		SetInfoText("Craft_RR Info.")
	elseif (option == Craft_FF)
		SetInfoText("Craft_RT Info.")
	elseif (option == OID_WeightClass)
		SetInfoText("OID_WeightClass Info.")
	elseif (option == OID_ArmorRating)
		SetInfoText("OID_ArmorRating Info.")
	elseif (option == Credit)
		SetInfoText("Credit Info.")
	endif	
	int i = 0
	While i < 6
		if (option == Craft_PureLight[i])
			SetInfoText("Craft_PureLight Info.")
		elseif (option == Craft_PlainLight[i])
			SetInfoText("Craft_PlainLight Info.")
		endif
		i += 1
	endWhile
endEvent

endState

;==========================================================================================================
; Nabee NPC Page
;==========================================================================================================

state NabeeNPCState

event OnOptionSelect(int option)
	string page = CurrentPage
	int i
	int p
	int ii
	if page == Pages[4]
		ii = 0
		p = 10
	elseif page == Pages[5]
		ii = 10
		p = 20
	elseif page == Pages[6]
		ii = 20
		p = 30
	endif
	i = ii
	While i < p && i < _rennNabeeFLST_NPCs.GetSize()
		if (option == NPC_X[i])
			;if ShowMessage(NPC.GetName() + "\n\n" + "Do you really want to unregister this NPC?", true)
			;	NPC = _rennNabeeFLST_NPCs.GetAt(i) as Actor
			;	NabeeGetBack()
			;	NabeeRemoveNPC()
			;	ShowMessage("Unregistered, and all of his/her Nabees returned.", false)
			;	ForcePageReset()
			;endif
			b_NPC_X[i] = !b_NPC_X[i]
			SetToggleOptionValue(NPC_X[i], b_NPC_X[i])
		endif
		if (option == NPC_T[i])
			if i_NPCNabee[i] > 0
				if ShowMessage(NPC.GetName() + "\n\n" + "Do you really want to get back all Nabees from this NPC?", true)
					NPC = _rennNabeeFLST_NPCs.GetAt(i) as Actor
					NabeeGetBack()
					ForcePageReset()
					ShowMessage("All Nabees returned.", false)
				endif
			endif
		endif
		i += 1
	endWhile
endEvent

event OnOptionMenuOpen(int option)
	if (option == NPC_X[NabeeLimit])
		SetMenuDialogOptions(s_NPC_X)
		SetMenuDialogStartIndex(0)
		SetMenuDialogDefaultIndex(0)
	endif
endEvent

event OnOptionMenuAccept(int option, int index)
	;-----------------------------------------;
	;	s_NPC_X[1] = Selected Get Back Nabees
	;	s_NPC_X[2] = Selected Unregister
	;	s_NPC_X[3] = All Get Back Nabees
	;	s_NPC_X[4] = All Unregister
	;-----------------------------------------;
	string page = CurrentPage
	int i
	int p
	int ii
	if page == Pages[4]
		ii = 0
		p = 10
	elseif page == Pages[5]
		ii = 10
		p = 20
	elseif page == Pages[6]
		ii = 20
		p = 30
	endif
	if (option == NPC_X[NabeeLimit])
		if index == 1
			if ShowMessage("Do you really want to get back all Nabees from selected NPCs in this page?", true)
				i = ii
				While i < p && i < _rennNabeeFLST_NPCs.GetSize()
					if b_NPC_X[i]
						NPC = _rennNabeeFLST_NPCs.GetAt(i) as Actor
						NabeeGetBack()
						b_NPC_X[i] = false
					endif
					i += 1
				endWhile
				ForcePageReset()
				ShowMessage("All Nabees returned.", false)
			endif
		elseif index == 3
			if ShowMessage("Do you really want to get back all Nabees from ALL NPCs?", true)
				i = 0
				While i < _rennNabeeFLST_NPCs.GetSize()
					NPC = _rennNabeeFLST_NPCs.GetAt(i) as Actor
					NabeeGetBack()
					i += 1
				endWhile
				ForcePageReset()
				ShowMessage("All Nabees returned.", false)
			endif
		elseif index == 2
			if ShowMessage("Do you really want to unregister selected NPCs in this page?", true)
				i = ii
				While i < p && i < _rennNabeeFLST_NPCs.GetSize()
					if b_NPC_X[i]
						NPC = _rennNabeeFLST_NPCs.GetAt(i) as Actor
						NabeeGetBack()
						NabeeRemoveNPC()
						b_NPC_X[i] = false
					endif
					i += 1
				endWhile
				ForcePageReset()
				ShowMessage("Unregistered, and all of their Nabees returned.", false)
			endif
		elseif index == 4
			if ShowMessage("Do you really want to unregister ALL NPCs?", true)
				i = 0
				While i < _rennNabeeFLST_NPCs.GetSize()
					NPC = _rennNabeeFLST_NPCs.GetAt(i) as Actor
					NabeeGetBack()
					NPC.RemoveFromFaction(_rennNabeeNPC_Faction)
					i += 1
				endWhile
				ForcePageReset()
				_rennNabeeFLST_NPCs.Revert()
				ShowMessage("Unregistered, and all of their Nabees returned.", false)
			endif
		endif
		SetMenuOptionValue(NPC_X[NabeeLimit], "[List Management]")
	endif
endEvent

event OnOptionHighlight(int option)
	if (option == NPC_X[NabeeLimit])
		;SetInfoText("MCM settings will be automatically applied to This NPC.\nIf clicked, you can unregister this NPC from 'Nabee Owners' and get back all his/her Nabees.")
		SetInfoText("MCM settings will be automatically applied to NPCs in this list.")
	elseif (option == NPC_T[NabeeLimit])
		if !b_ShowLocation
			SetInfoText("If clicked, you can get back all Nabees from this NPC.")
		else
			SetInfoText("Nabee's count),  Location,  O) Equipped,  X) Unequipped.\n" + "If clicked, you can get back all Nabees from this NPC.")
		endif
	endif
endEvent

endState

function NabeeGetBack()
	if NPC != none
		int j = 0
		int Count = 0
		While j < _rennNabeeFLST_Armors.GetSize()
			NabeeArmor = _rennNabeeFLST_Armors.GetAt(j) as Armor
			if NPC.IsEquipped(NabeeArmor)
				NPC.UnEquipItem(NabeeArmor, abSilent = true)
			endif
			Count = NPC.GetItemCount(NabeeArmor)
			if Count > 0
				NPC.RemoveItem(NabeeArmor, Count, abSilent = true)
				PlayerRef.AddItem(NabeeArmor, Count, abSilent = false)
			endif
			j += 1
		endWhile
	endif
endFunction

;==========================================================================================================
; Dwelling, DwellingX Page
;==========================================================================================================

state NabeeDwellingState

event OnOptionSelect(int option)
	if (option == Dwelling_[DwellingLimit + 2])
		;---------------------------------------------------------------------;
		; Interior
		; 1		[Registered]= Dwelling Keyword X
		; 10	[Register]	= Dwelling Keyword X,  Registered as Non-Dwelling
		; 11	[Register]	= Dwelling Keyword O,  Registered as Non-Dwelling
		; 12	[Register]	= Dwelling Keyword X
		;---------------------------------------------------------------------;
		if i_Dwelling_ == 11 || i_Dwelling_ == 10
			if ShowMessage("Current location is already registered as Non-Dwelling.\n\n" + "Do you really want to Register current location as Dwelling?", true)
				_rennNabeeFLST_DwellingX.RemoveAddedForm(CurrentLocation)
				ForcePageReset()
				if i_Dwelling_ == 11
					ShowMessage("Removed from Non-Dwelling List.\n\n" + "Skipped registration: " + "Current location has LocTypeDwelling keyword.", false)
				else
					_rennNabeeFLST_Dwelling.AddForm(CurrentLocation)
					ShowMessage("Removed from Non-Dwelling List.\n\n" + "Registered as Dwelling.", false)
				endif
				b_ApplyNabeeRefresh = true
			endif
		elseif i_Dwelling_ == 12
			if ShowMessage("Do you really want to Register current location as Dwelling?", true)
				_rennNabeeFLST_Dwelling.AddForm(CurrentLocation)
				ForcePageReset()
				ShowMessage("Registered as Dwelling.", false)
				b_ApplyNabeeRefresh = true
			endif
		elseif i_Dwelling_ == 1
			if ShowMessage("Do you really want to Unregister current location from Dwelling List?", true)
				_rennNabeeFLST_Dwelling.RemoveAddedForm(CurrentLocation)
				ForcePageReset()
				ShowMessage("Unregistered.", false)
				b_ApplyNabeeRefresh = true
			endif
		endif
	elseif (option == DwellingX_[DwellingXLimit + 2])
		;---------------------------------------------------------------------;
		; 1		[Registered]= Dwelling Keyword O
		; 10	[Register]	= Dwelling Keyword O
		; 11	[Register]	= Dwelling Keyword X,  Registered as Dwelling
		; 12	[Register]	= Dwelling Keyword X,  Dungeon Keyword X
		;---------------------------------------------------------------------;
		if i_DwellingX_ == 11
			if ShowMessage("Current location is already registered as Dwelling.\n\n" + "Do you really want to Register current location as Non-Dwelling?", true)
				_rennNabeeFLST_Dwelling.RemoveAddedForm(CurrentLocation)
				ForcePageReset()
				if !HasKeyWordDungeon()
					_rennNabeeFLST_DwellingX.AddForm(CurrentLocation)
					ShowMessage("Removed from Dwelling List.\n\n" + "Registered as Non-Dwelling.", false)
				else
					ShowMessage("Removed from Dwelling List.\n\n" + "Skipped registration: " + "Current location has LocTypeDungeon keyword.", false)
				endif
				b_ApplyNabeeRefresh = true
			endif
		elseif i_DwellingX_ == 10 || i_DwellingX_ == 12
			if ShowMessage("Do you really want to Register current location as Non-Dwelling?", true)
				_rennNabeeFLST_DwellingX.AddForm(CurrentLocation)
				ForcePageReset()
				ShowMessage("Registered as Non-Dwelling.", false)
				b_ApplyNabeeRefresh = true
			endif
		elseif i_DwellingX_ == 1
			if ShowMessage("Do you really want to Unregister current location from Non-Dwelling List?", true)
				_rennNabeeFLST_DwellingX.RemoveAddedForm(CurrentLocation)
				ForcePageReset()
				ShowMessage("Unregistered.", false)
				b_ApplyNabeeRefresh = true
			endif
		endif
	endif
	string page = CurrentPage
	int i
	int p
	int ii
	if page == Pages[8] || page == Pages[12]
		ii = 0
		p = 30
	elseif page == Pages[9] || page == Pages[13]
		ii = 30
		p = 60
	elseif page == Pages[10]
		ii = 60
		p = 90
	endif
	if (option == Dwelling_[DwellingLimit + 1])
		if ShowMessage("Do you really want to Unregister selected locations from Dwelling List?", true)
			i = ii
			While i < p && i < _rennNabeeFLST_Dwelling.GetSize()
				if b_Dwelling_[i]
					Dwelling = _rennNabeeFLST_Dwelling.GetAt(i) as Location
					if CurrentLocation == Dwelling
						b_ApplyNabeeRefresh = true
					endif
					if Dwelling != none
						_rennNabeeFLST_Dwelling.RemoveAddedForm(Dwelling)
						b_Dwelling_[i] = false
					endif
				endif
				i += 1
			endWhile
			ForcePageReset()
			ShowMessage("Unregistered.", false)
		endif
	elseif (option == DwellingX_[DwellingXLimit + 1])
		if ShowMessage("Do you really want to Unregister selected locations from Non-Dwelling List?", true)
			i = ii
			While i < p && i < _rennNabeeFLST_DwellingX.GetSize()
				if b_DwellingX_[i]
					Dwelling = _rennNabeeFLST_DwellingX.GetAt(i) as Location
					if CurrentLocation == Dwelling
						b_ApplyNabeeRefresh = true
					endif
					if Dwelling != none
						_rennNabeeFLST_DwellingX.RemoveAddedForm(Dwelling)
						b_DwellingX_[i] = false
					endif
				endif
				i += 1
			endWhile
			ForcePageReset()
			ShowMessage("Unregistered.", false)
		endif
	endif
	i = ii
	While i < p && i < _rennNabeeFLST_Dwelling.GetSize()
		if (option == Dwelling_[i])
			;Dwelling = _rennNabeeFLST_Dwelling.GetAt(i) as Location
			;if ShowMessage(Dwelling.GetName() + "\n\n" + "Do you really want to Unregister this location from Dwelling List?", true)
			;	if IsCurrentLocation()
			;		b_ApplyNabeeRefresh = true
			;	endif
			;	_rennNabeeFLST_Dwelling.RemoveAddedForm(Dwelling)
			;	ShowMessage("Unregistered.", false)
			;	ForcePageReset()
			;endif
			b_Dwelling_[i] = !b_Dwelling_[i]
			SetToggleOptionValue(Dwelling_[i], b_Dwelling_[i])
		endif
		i += 1
	endWhile
	i = ii
	While i < p && i < _rennNabeeFLST_DwellingX.GetSize()
		if (option == DwellingX_[i])
			;Dwelling = _rennNabeeFLST_DwellingX.GetAt(i) as Location
			;if ShowMessage(Dwelling.GetName() + "\n\n" + "Do you really want to Unregister this location from Non-Dwelling List?", true)
			;	if IsCurrentLocation()
			;		b_ApplyNabeeRefresh = true
			;	endif
			;	_rennNabeeFLST_DwellingX.RemoveAddedForm(Dwelling)
			;	ShowMessage("Unregistered.", false)
			;	ForcePageReset()
			;endif
			b_DwellingX_[i] = !b_DwellingX_[i]
			SetToggleOptionValue(DwellingX_[i], b_DwellingX_[i])
		endif
		i += 1
	endWhile
endEvent

event OnOptionMenuOpen(int option)
	if (option == Dwelling_[DwellingLimit + 3])
		SetMenuDialogOptions(DwellingMenuList)
		SetMenuDialogStartIndex(0)
		SetMenuDialogDefaultIndex(0)
	elseif (option == DwellingX_[DwellingXLimit + 3])
		SetMenuDialogOptions(DwellingXMenuList)
		SetMenuDialogStartIndex(0)
		SetMenuDialogDefaultIndex(0)
	endif
endEvent

event OnOptionMenuAccept(int option, int index)
	if (option == Dwelling_[DwellingLimit + 3])
		if index == 1
			if ShowMessage("Do you really want to Clear All this list?", true)
				if HasCurrentLocation()
					b_ApplyNabeeRefresh = true
				endif
				_rennNabeeFLST_Dwelling.Revert()
				ForcePageReset()
				ShowMessage("Cleared.", false)
			endif
		elseif index == 2
			if ShowMessage("Do you really want to Add Default Locations?", true)
				int i = 0
				While i < _rennNabeeFLST_DwellingDefault.GetSize() && _rennNabeeFLST_Dwelling.GetSize() < 60
					Dwelling = _rennNabeeFLST_DwellingDefault.GetAt(i) as Location
					if !_rennNabeeFLST_Dwelling.HasForm(Dwelling)
						if _rennNabeeFLST_DwellingX.HasForm(Dwelling)
							if ShowMessage(Dwelling.GetName() + "\n\n" + "This location is already registered as Non-Dwelling.\n" + "Do you really want to Register this location as Dwelling?", true)
								_rennNabeeFLST_DwellingX.RemoveAddedForm(Dwelling)
								_rennNabeeFLST_Dwelling.AddForm(Dwelling)
							endif
						else
							_rennNabeeFLST_Dwelling.AddForm(Dwelling)
						endif
					endif
					i += 1
				endWhile
				ForcePageReset()
				ShowMessage("Added Default Locations.", false)
				if HasCurrentLocation()
					b_ApplyNabeeRefresh = true
				endif
			endif
		endif
		SetMenuOptionValue(Dwelling_[DwellingLimit + 3], "[Reset List]")
	elseif (option == DwellingX_[DwellingXLimit + 3])
		if index == 1
			if ShowMessage("Do you really want to Clear All this list?", true)
				if XHasCurrentLocation()
					b_ApplyNabeeRefresh = true
				endif
				_rennNabeeFLST_DwellingX.Revert()
				ForcePageReset()
				ShowMessage("Cleared.", false)
			endif
		elseif index == 2
			if ShowMessage("Do you really want to Add Default Locations?", true)
				int i = 0
				While i < _rennNabeeFLST_DwellingXDefault.GetSize() && _rennNabeeFLST_DwellingX.GetSize() < DwellingXLimit
					Dwelling = _rennNabeeFLST_DwellingXDefault.GetAt(i) as Location
					if !_rennNabeeFLST_DwellingX.HasForm(Dwelling)
						if _rennNabeeFLST_Dwelling.HasForm(Dwelling)
							if ShowMessage(Dwelling.GetName() + "\n\n" + "This location is already registered as Dwelling.\n" + "Do you really want to Register this location as Non-Dwelling?", true)
								_rennNabeeFLST_Dwelling.RemoveAddedForm(Dwelling)
								_rennNabeeFLST_DwellingX.AddForm(Dwelling)
							endif
						else
							_rennNabeeFLST_DwellingX.AddForm(Dwelling)
						endif
					endif
					i += 1
				endWhile
				ForcePageReset()
				ShowMessage("Added Default Locations.", false)
				if XHasCurrentLocation()
					b_ApplyNabeeRefresh = true
				endif
			endif
		elseif index == 3
			if !Check_DLC()
				ShowMessage("DLC not detected.", true)
			else
				if ShowMessage("Do you really want to Add DLC Default Locations?", true)
					Apply_DLC()
					ForcePageReset()
					ShowMessage("Added DLC Default Locations.", false)
					if XHasCurrentLocation()
						b_ApplyNabeeRefresh = true
					endif
				endif
			endif
		endif
		SetMenuOptionValue(DwellingX_[DwellingXLimit + 3], "[Reset List]")
	endif
endEvent

event OnOptionHighlight(int option)
	if (option == Dwelling_[DwellingLimit + 3])
		SetInfoText("Default Dwelling List: Non-Hostile Interiors missed 'LoctypeDwelling' keyword.")
	elseif (option == DwellingX_[DwellingXLimit + 3])
		SetInfoText("Default Non-Dwelling List: Semi-dungeons assigned 'LoctypeDwelling' keyword, or dungeons missed 'LocTypeDungeon' keyword.")
	elseif (option == Dwelling_[DwellingLimit + 2])
		SetInfoText("Register/Unregister current location as Dwelling.")
	elseif (option == DwellingX_[DwellingXLimit + 2])
		SetInfoText("Register/Unregister current location as Non-Dwelling.")
	elseif (option == Dwelling_[DwellingLimit + 1] || option == DwellingX_[DwellingXLimit + 1])
		SetInfoText("Unregister selected locations in this page.")
	endif
endEvent

endState

;==========================================================================================================
; Apply Function
;==========================================================================================================

bool function HasCurrentLocation()
	if _rennNabeeFLST_Dwelling.HasForm(CurrentLocation)
		return true
	else
		return false
	endif
endFunction

bool function XHasCurrentLocation()
	if _rennNabeeFLST_DwellingX.HasForm(CurrentLocation)
		return true
	else
		return false
	endif
endFunction

bool function IsCurrentLocation()
	if Dwelling == CurrentLocation
		return true
	else
		return false
	endif
endFunction

bool function HasKeyWordDwelling()
	if CurrentLocation.HasKeyword(LocTypeDwelling)
		return true
	else
		return false
	endif
endFunction

bool function HasKeyWordDungeon()
	if CurrentLocation.HasKeyword(LocTypeDungeon)
		return true
	else
		return false
	endif
endFunction

function NabeeRemoveNPC()
	_rennNabeeFLST_NPCs.RemoveAddedForm(NPC)
	NPC.RemoveFromFaction(_rennNabeeNPC_Faction)
endFunction

function NabeeSneakValue()
	_NabeeSneakValue_ST.SetValue(SneakValue_ST_Var)
	_NabeeSneakValue_RT.SetValue(SneakValue_RT_Var)
	_NabeeSneakValue_FF.SetValue(SneakValue_FF_Var)
	_NabeeSneakValue_Dungeon.SetValue(SneakValue_Dungeon_Var)
	_NabeeSneakValue_Night.SetValue(SneakValue_Night_Var)
endFunction

function ApplyNabeeSneakValue()
	_rennNabeeSneakST_Perk.SetNthEntryValue(0, 1, _NabeeSneakValue_ST.GetValue())
	_rennNabeeSneakRT_Perk.SetNthEntryValue(0, 1, _NabeeSneakValue_RT.GetValue())
	_rennNabeeSneakFF_Perk.SetNthEntryValue(0, 1, _NabeeSneakValue_FF.GetValue())
	_rennNabeeSneakST_Perk.SetNthEntryValue(1, 1, _NabeeSneakValue_FF.GetValue())
	_rennNabeeSneakRT_Perk.SetNthEntryValue(1, 1, _NabeeSneakValue_FF.GetValue())
	_rennNabeeDungeon_Perk.SetNthEntryValue(0, 1, _NabeeSneakValue_Dungeon.GetValue())
	_rennNabeeNight_Perk.SetNthEntryValue(0, 1, _NabeeSneakValue_Night.GetValue())
endFunction

function NabeeCraftValue()
	;------------------------------;
	; Pure: 1 or 11 / Plain: >= 10
	;------------------------------;
	int i_NabeeCraft_FF		= b_Craft_PureLight[0] as int + ((b_Craft_PlainLight[0] as int) * 10)
	int i_NabeeCraft_FFT	= b_Craft_PureLight[1] as int + ((b_Craft_PlainLight[1] as int) * 10)
	int i_NabeeCraft_ST		= b_Craft_PureLight[2] as int + ((b_Craft_PlainLight[2] as int) * 10)
	int i_NabeeCraft_T		= b_Craft_PureLight[3] as int + ((b_Craft_PlainLight[3] as int) * 10)
	int i_NabeeCraft_RT		= b_Craft_PureLight[4] as int + ((b_Craft_PlainLight[4] as int) * 10)
	int i_NabeeCraft_RR		= b_Craft_PureLight[5] as int
	_NabeeCraft_FF.SetValue(i_NabeeCraft_FF)
	_NabeeCraft_FFT.SetValue(i_NabeeCraft_FFT)
	_NabeeCraft_ST.SetValue(i_NabeeCraft_ST)
	_NabeeCraft_T.SetValue(i_NabeeCraft_T)
	_NabeeCraft_RT.SetValue(i_NabeeCraft_RT)
	_NabeeCraft_RR.SetValue(i_NabeeCraft_RR)
endFunction

function ArrangeNPC()
	int i = 0
	While i < _rennNabeeFLST_NPCs.GetSize()
		NPC = _rennNabeeFLST_NPCs.GetAt(i) as Actor
		if NPC != none
			if !NPC.isDead() && !NPC.IsDisabled()
				_rennNabeeFLST_Temp.AddForm(NPC)
			endif
		endif
		i += 1
	endWhile
	_rennNabeeFLST_NPCs.Revert()
	Utility.Wait(1)
	i = 0
	While i < _rennNabeeFLST_Temp.GetSize()
		NPC = _rennNabeeFLST_Temp.GetAt(i) as Actor
		_rennNabeeFLST_NPCs.AddForm(NPC)
		i += 1
	endWhile
	_rennNabeeFLST_Temp.Revert()
	Utility.Wait(1)
endFunction

function ArrangeDwelling()
	int i = 0
	While i < _rennNabeeFLST_Dwelling.GetSize()
		Dwelling = _rennNabeeFLST_Dwelling.GetAt(i) as Location
		if Dwelling != none
			_rennNabeeFLST_Temp.AddForm(Dwelling)
		endif
		i += 1
	endWhile
	_rennNabeeFLST_Dwelling.Revert()
	Utility.Wait(1)
	i = 0
	While i < _rennNabeeFLST_Temp.GetSize()
		Dwelling = _rennNabeeFLST_Temp.GetAt(i) as Location
		_rennNabeeFLST_Dwelling.AddForm(Dwelling)
		i += 1
	endWhile
	_rennNabeeFLST_Temp.Revert()
	Utility.Wait(1)
endFunction

function ArrangeDwellingX()
	int i = 0
	While i < _rennNabeeFLST_DwellingX.GetSize()
		Dwelling = _rennNabeeFLST_DwellingX.GetAt(i) as Location
		if Dwelling != none
			_rennNabeeFLST_Temp.AddForm(Dwelling)
		endif
		i += 1
	endWhile
	_rennNabeeFLST_DwellingX.Revert()
	Utility.Wait(1)
	i = 0
	While i < _rennNabeeFLST_Temp.GetSize()
		Dwelling = _rennNabeeFLST_Temp.GetAt(i) as Location
		_rennNabeeFLST_DwellingX.AddForm(Dwelling)
		i += 1
	endWhile
	_rennNabeeFLST_Temp.Revert()
	Utility.Wait(1)
endFunction

;==========================================================================================================
; Refresh Function : Enchantment, OnOff
;==========================================================================================================

function ApplyNabeeEnchFF()
	int e_FF = SneakIndex_FF
	int i = 0
	While i < 3		;_Direction_ 3
		;----- Sneak 2 * House 1 = 2
		_NabeeFF01_Armor[i].SetEnchantment(_rennNabeeFF01_Ench[e_FF + (i*2)])
		_NabeeFF02_Armor[i].SetEnchantment(_rennNabeeFF02_Ench[e_FF + (i*2)])
		_NabeeFF01_Armor[i + 3].SetEnchantment(_rennNabeeFF01_Ench[e_FF + (i*2)])
		_NabeeFF02_Armor[i + 3].SetEnchantment(_rennNabeeFF02_Ench[e_FF + (i*2)])
		i += 1
	endWhile
endFunction

function ApplyNabeeEnchST()
	int e_ST = (SneakIndex_ST * 2) + (1 - HouseIndex_ST)
	int i = 0
	While i < 3		;_Direction_ 3
		;----- Sneak 4 * House 2 = 8
		_NabeeST01_Armor[i].SetEnchantment(_rennNabeeST01_Ench[e_ST + (i*8)])
		_NabeeST02_Armor[i].SetEnchantment(_rennNabeeST02_Ench[e_ST + (i*8)])
		_NabeeST01_Armor[i + 3].SetEnchantment(_rennNabeeST01_Ench[e_ST + (i*8)])
		_NabeeST02_Armor[i + 3].SetEnchantment(_rennNabeeST02_Ench[e_ST + (i*8)])
		i += 1
	endWhile
endFunction

function ApplyNabeeEnchRT()
	int e_RT = (SneakIndex_RT * 2) + (1 - HouseIndex_RT)
	int i = 0
	While i < 3		;_Direction_ 3
		;----- Sneak 4 * House 2 = 8
		_NabeeRT01_Armor[i].SetEnchantment(_rennNabeeRT01_Ench[e_RT + (i*8)])
		_NabeeRT02_Armor[i].SetEnchantment(_rennNabeeRT02_Ench[e_RT + (i*8)])
		i += 1
	endWhile
	_NabeeRR01_Armor.SetEnchantment(_rennNabeeRR01_Ench[e_RT])
	_NabeeRR02_Armor.SetEnchantment(_rennNabeeRR02_Ench[e_RT])
endFunction

bool function NabeeRefresh_0()
	if NabeeKey._NabeeLight.GetValue() as int != 1
		return false
	else
		NabeeKey._NabeeLight.SetValue(0)
		return true
	endif
endFunction

function NabeeRefresh_1()
	Utility.Wait(0.5)
	NabeeKey._NabeeLight.SetValue(1)
endFunction

function NabeeRefresh()
	;======================================= Player
	NabeeArmor = PlayerRef.GetWornForm(0x80000000) as Armor
	if _rennNabeeFLST_Armors.HasForm(NabeeArmor)
	;if PlayerRef.isEquipped(_rennNabeeFLST_Armors)
	;	NabeeArmor = PlayerRef.GetWornForm(0x80000000) as Armor
		PlayerRef.UnEquipItem(NabeeArmor, abPreventEquip = true, abSilent = true)
		Utility.Wait(0.3)
		PlayerRef.EquipItem(NabeeArmor, abPreventRemoval = false, abSilent = true)
	endif
	;======================================= NPC
	int i = 0
	While i < _rennNabeeFLST_NPCs.GetSize() && i < NabeeLimit
		NPC = _rennNabeeFLST_NPCs.GetAt(i) as Actor
		if NPC != none
			if NPC.isDead() || NPC.IsDisabled()
				NabeeRemoveNPC()
			else
				NabeeArmor = NPC.GetWornForm(0x80000000) as Armor
				if _rennNabeeFLST_Armors.HasForm(NabeeArmor)
				;if NPC.IsEquipped(_rennNabeeFLST_Armors)
				;	NabeeArmor = NPC.GetWornForm(0x80000000) as Armor
					NPC.UnEquipItem(NabeeArmor, abPreventEquip = true, abSilent = true)
					Utility.Wait(0.3)
					NPC.EquipItem(NabeeArmor, abPreventRemoval = true, abSilent = true)
				endif
			endif
		endif
		i += 1
	endWhile
endFunction

function ApplyAllReady()
	b_ApplyNabeeSpellFF				= true
	b_ApplyNabeeSpellST				= true
	b_ApplyNabeeSpellRT				= true
	b_ApplyNabeeRadiusFF			= true
	b_ApplyNabeeRadiusST			= true
	b_ApplyNabeeRadiusRT			= true
	b_ApplyNabeeClass				= true
	b_ApplyNabeeEnchFF				= true
	b_ApplyNabeeEnchST				= true
	b_ApplyNabeeEnchRT				= true
	b_NabeeSneakValue				= true
	b_NabeeCraftValue				= true
	b_ApplyNabeeRefresh				= true
endFunction

function ApplyAllDone()
	b_ApplyNabeeSpellFF				= false
	b_ApplyNabeeSpellST				= false
	b_ApplyNabeeSpellRT				= false
	b_ApplyNabeeRadiusFF			= false
	b_ApplyNabeeRadiusST			= false
	b_ApplyNabeeRadiusRT			= false
	b_ApplyNabeeClass				= false
	b_ApplyNabeeEnchFF				= false
	b_ApplyNabeeEnchST				= false
	b_ApplyNabeeEnchRT				= false
	b_NabeeSneakValue				= false
	b_NabeeCraftValue				= false
	b_ApplyNabeeRefresh				= false
endFunction

;==========================================================================================================
; Reload Function : Spell, Radius, Armor Class/Rating
;==========================================================================================================

function ApplyNabeeSpellFF()
	int i = 0
	While i < _C_		;_Condition_ 5 * _Direction_ 1
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeFF01_Spell[i], _rennNabeeFF01_Effect[BrightnessIndex_FF[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeFF01L_Spell[i], _rennNabeeFF01L_Effect[BrightnessIndex_FF[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeFF01R_Spell[i], _rennNabeeFF01R_Effect[BrightnessIndex_FF[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeFF02_Spell[i], _rennNabeeFF02_Effect[BrightnessIndex_FF[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeFF02L_Spell[i], _rennNabeeFF02L_Effect[BrightnessIndex_FF[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeFF02R_Spell[i], _rennNabeeFF02R_Effect[BrightnessIndex_FF[i] + (i * _B_)], 0)
		i += 1
	endWhile
endFunction

function ApplyNabeeSpellST()
	int i = 0
	While i < _C_		;_Condition_ 5 * _Direction_ 1
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeST01_Spell[i], _rennNabeeST01_Effect[BrightnessIndex_ST[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeST01L_Spell[i], _rennNabeeST01L_Effect[BrightnessIndex_ST[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeST01R_Spell[i], _rennNabeeST01R_Effect[BrightnessIndex_ST[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeST02_Spell[i], _rennNabeeST02_Effect[BrightnessIndex_ST[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeST02L_Spell[i], _rennNabeeST02L_Effect[BrightnessIndex_ST[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeST02R_Spell[i], _rennNabeeST02R_Effect[BrightnessIndex_ST[i] + (i * _B_)], 0)
		i += 1
	endWhile
endFunction

function ApplyNabeeSpellRT()
	int i = 0
	While i < _C_	 	;_Condition_ 5 * _Direction_ 1
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeRT01_Spell[i], _rennNabeeRT01_Effect[BrightnessIndex_RT[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeRT01L_Spell[i], _rennNabeeRT01L_Effect[BrightnessIndex_RT[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeRT01R_Spell[i], _rennNabeeRT01R_Effect[BrightnessIndex_RT[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeRT02_Spell[i], _rennNabeeRT02_Effect[BrightnessIndex_RT[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeRT02L_Spell[i], _rennNabeeRT02L_Effect[BrightnessIndex_RT[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeRT02R_Spell[i], _rennNabeeRT02R_Effect[BrightnessIndex_RT[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeRR01_Spell[i], _rennNabeeRR01_Effect[BrightnessIndex_RT[i] + (i * _B_)], 0)
		grimytoolspluginscript.SetSpellNthMagicEffect(_rennNabeeRR02_Spell[i], _rennNabeeRR02_Effect[BrightnessIndex_RT[i] + (i * _B_)], 0)
		i += 1
	endWhile
endFunction

;---------------------------------------------------------------------------------------------------

function ApplyNabeeRadiusFF()
	int i = 0
	int bb = 0
	While i < _C_		;_Condition_ 5		
		grimytoolspluginscript.SetLightRadius(_rennNabeeFF01_Light[(i * _B_) + bb], Radius_FF_Var[i])
		grimytoolspluginscript.SetLightRadius(_rennNabeeFF02_Light[(i * _B_) + bb], Radius_FF_Var[i])
		bb += 1
		if bb == _B_
			bb = 0
			i += 1
		endif
	endWhile
endFunction

function ApplyNabeeRadiusST()
	int i = 0
	int bb = 0
	While i < _C_		;_Condition_ 5
		grimytoolspluginscript.SetLightRadius(_rennNabeeST01_Light[(i * _B_) + bb], Radius_ST_Var[i])
		grimytoolspluginscript.SetLightRadius(_rennNabeeST02_Light[(i * _B_) + bb], Radius_ST_Var[i])
		bb += 1
		if bb == _B_
			bb = 0
			i += 1
		endif
	endWhile
endFunction

function ApplyNabeeRadiusRT()
	int i = 0
	int bb = 0
	While i < _C_		;_Condition_ 5
		grimytoolspluginscript.SetLightRadius(_rennNabeeRT01_Light[(i * _B_) + bb], Radius_RT_Var[i])
		grimytoolspluginscript.SetLightRadius(_rennNabeeRT02_Light[(i * _B_) + bb], Radius_RT_Var[i])
		bb += 1
		if bb == _B_
			bb = 0
			i += 1
		endif
	endWhile
endFunction

bool function ApplyWeightClass()
	if i_WeightClass == 2
		return false
	else
		int i = 0
		While i < _rennNabeeFLST_Armors.GetSize()
			NabeeArmor = _rennNabeeFLST_Armors.GetAt(i) as Armor
			NabeeArmor.SetWeightClass(i_WeightClass)
			i += 1
		endWhile
		_ArmorWeightClass.SetValue(i_WeightClass)
		return true
	endif
endFunction

function ApplyArmorRating()
	int i = 0
	While i < _rennNabeeFLST_Armors.GetSize()
		NabeeArmor = _rennNabeeFLST_Armors.GetAt(i) as Armor
		NabeeArmor.SetAR(ArmorRating_Var)
		i += 1
	endWhile
	_ArmorRating.SetValue(ArmorRating_Var)
endFunction

;==========================================================================================================
; FISS
;==========================================================================================================

bool function SaveFISS()
	FISSInterface fiss = FISSFactory.getFISS()
	if fiss
		fiss.beginSave("DwemerNabee.xml", "Dwemer Nabee")
		fiss.saveInt("HouseIndex_ST", HouseIndex_ST)
		fiss.saveInt("HouseIndex_RT", HouseIndex_RT)
		fiss.saveInt("SneakIndex_ST", SneakIndex_ST)
		fiss.saveInt("SneakIndex_RT", SneakIndex_RT)
		fiss.saveInt("SneakIndex_FF", SneakIndex_FF)
		fiss.saveFloat("_NabeeSneakValue_ST", SneakValue_ST_Var)
		fiss.saveFloat("_NabeeSneakValue_RT", SneakValue_RT_Var)
		fiss.saveFloat("_NabeeSneakValue_FF", SneakValue_FF_Var)
		;fiss.saveFloat("_NabeeSneakValue_Facelight", SneakValue_Facelight_Var)
		fiss.saveFloat("_NabeeSneakValue_Night", SneakValue_Night_Var)
		int i = 0
		While i < 6
			fiss.saveBool("b_Craft_PureLight" + i as string, b_Craft_PureLight[i])
			fiss.saveBool("b_Craft_PlainLight" + i as string, b_Craft_PlainLight[i])
			i += 1
		endWhile
		fiss.saveBool("b_NabeeHotkeyEnable", b_NabeeHotkeyEnable)
		fiss.saveInt("NabeeHotkey", NabeeKey.NabeeHotkey)
		fiss.saveInt("NabeeCycleHotkey", NabeeKey.NabeeCycleHotkey)
		fiss.saveBool("b_InventorySpell", b_InventorySpell)
		fiss.saveBool("b_ShowLocation", b_ShowLocation)
		;=======================
		float FISS_EXTRA_1 = 3.5
		fiss.saveFloat("FISS_EXTRA_1", FISS_EXTRA_1)
		fiss.saveFloat("_NabeeReactionTime", _NabeeReactionTime.GetValue())
		fiss.saveFloat("_7", _7.GetValue())
		fiss.saveFloat("_19", _19.GetValue())
		fiss.saveFloat("SneakValue_Dungeon_Var", SneakValue_Dungeon_Var)
		string sfiss_Dwelling_
		string sfiss_DwellingX_
		int Dwelling_ListSize	= _rennNabeeFLST_Dwelling.GetSize()
		int DwellingX_ListSize	= _rennNabeeFLST_DwellingX.GetSize()
		int ii = 0
		int ix = 0
		While ii < Dwelling_ListSize
			Dwelling = _rennNabeeFLST_Dwelling.GetAt(ii) as Location
			if Dwelling == none
				ix += 1
			else
				fiss.saveInt("sfiss_Dwelling_" + ii as string, Dwelling.GetFormID())
			endif
			ii += 1
		endWhile
		fiss.saveInt("Dwelling_ListSize", Dwelling_ListSize - ix)
		ii = 0
		ix = 0
		While ii < DwellingX_ListSize
			Dwelling = _rennNabeeFLST_DwellingX.GetAt(ii) as Location
			if Dwelling == none
				ix += 1
			else
				fiss.saveInt("sfiss_DwellingX_" + ii as string, Dwelling.GetFormID())
			endif
			ii += 1
		endWhile
		fiss.saveInt("DwellingX_ListSize", DwellingX_ListSize - ix)
		;=======================
		float FISS_EXTRA_2 = 4.2
		fiss.saveFloat("FISS_EXTRA_2", FISS_EXTRA_2)
		fiss.saveInt("i_WeightClass", i_WeightClass)
		fiss.saveInt("ArmorRating_Var", ArmorRating_Var)
		fiss.saveInt("i_DebugMSG", i_DebugMSG)
		i = 0
		While i < _C_ + 1 ;6 _Condition_ + 1
			fiss.saveInt("BrightnessIndex_ST_" + i as string, BrightnessIndex_ST[i])
			fiss.saveInt("BrightnessIndex_FF_" + i as string, BrightnessIndex_FF[i])
			fiss.saveInt("BrightnessIndex_RT_" + i as string, BrightnessIndex_RT[i])
			fiss.saveInt("Radius_FF_Var_" + i as string, Radius_FF_Var[i])
			fiss.saveInt("Radius_ST_Var_" + i as string, Radius_ST_Var[i])
			fiss.saveInt("Radius_RT_Var_" + i as string, Radius_RT_Var[i])
			i += 1
		endWhile
		
		string result = fiss.endSave()
		if result != ""
			Debug.Trace("Error saving user settings: " + result)
			return false
		endif
	endif
	return true
endFunction

bool function LoadFISS()
	FISSInterface fiss = FISSFactory.getFISS()
	if fiss
		fiss.beginLoad("DwemerNabee.xml")
		HouseIndex_ST = fiss.loadInt("HouseIndex_ST")
		HouseIndex_RT = fiss.loadInt("HouseIndex_RT")
		SneakIndex_ST = fiss.loadInt("SneakIndex_ST")
		SneakIndex_RT = fiss.loadInt("SneakIndex_RT")
		SneakIndex_FF = fiss.loadInt("SneakIndex_FF")
		SneakValue_ST_Var = fiss.loadFloat("_NabeeSneakValue_ST")
		SneakValue_RT_Var = fiss.loadFloat("_NabeeSneakValue_RT")
		SneakValue_FF_Var = fiss.loadFloat("_NabeeSneakValue_FF")
		SneakValue_Night_Var = fiss.loadFloat("_NabeeSneakValue_Night")
		int i = 0
		While i < 6
			b_Craft_PureLight[i] = fiss.loadBool("b_Craft_PureLight" + i as string)
			b_Craft_PlainLight[i] = fiss.loadBool("b_Craft_PlainLight" + i as string)
			i += 1
		endWhile		
		b_NabeeHotkeyEnable = fiss.loadBool("b_NabeeHotkeyEnable")
		NabeeKey.NabeeHotkey = fiss.loadInt("NabeeHotkey")
		NabeeKey.NabeeCycleHotkey = fiss.loadInt("NabeeCycleHotkey")	
		b_ShowLocation = fiss.loadBool("b_ShowLocation")
		b_InventorySpell = fiss.loadBool("b_InventorySpell")
		;==================================================
		float FISS_EXTRA_1 = fiss.loadFloat("FISS_EXTRA_1")
		if FISS_EXTRA_1 == 3.5
			_NabeeReactionTime.SetValue(fiss.loadFloat("_NabeeReactionTime"))
			_7.SetValue(fiss.loadFloat("_7"))
			_19.SetValue(fiss.loadFloat("_19"))
			SneakValue_Dungeon_Var = fiss.loadFloat("SneakValue_Dungeon_Var")
			if b_loadFISSDwelling
				int Dwelling_ListSize	= fiss.loadInt("Dwelling_ListSize")
				int DwellingX_ListSize	= fiss.loadInt("DwellingX_ListSize")
				int ii = 0
				While ii < Dwelling_ListSize
					form fissDwelling = Game.GetForm(fiss.loadInt("sfiss_Dwelling_" + ii as string))
					if fissDwelling != none
						if _rennNabeeFLST_Dwelling.HasForm(fissDwelling)
							_rennNabeeFLST_Dwelling.AddForm(fissDwelling)
						endif
					endif
					ii += 1
				endWhile
				ii = 0
				While ii < DwellingX_ListSize
					form fissDwelling = Game.GetForm(fiss.loadInt("sfiss_DwellingX_" + ii as string))
					if fissDwelling != none
						if !_rennNabeeFLST_DwellingX.HasForm(fissDwelling)
							_rennNabeeFLST_DwellingX.AddForm(fissDwelling)
						endif
					endif
					ii += 1
				endWhile
			endif
		else
			if HouseIndex_ST != 1
				HouseIndex_ST = 1 - (HouseIndex_ST / 2)
			endif
			if HouseIndex_RT != 1
				HouseIndex_RT = 1 - (HouseIndex_RT / 2)
			endif
		endif
		;==================================================
		float FISS_EXTRA_2 = fiss.loadFloat("FISS_EXTRA_2")
		if FISS_EXTRA_2 == 4.2
			i_WeightClass = fiss.loadInt("i_WeightClass")
			ArmorRating_Var = fiss.loadInt("ArmorRating_Var")
			i_DebugMSG = fiss.loadInt("i_DebugMSG")
			i = 0
			While i < 6 	;_Condition_ + 1
				BrightnessIndex_ST[i] = fiss.loadInt("BrightnessIndex_ST_" + i as string)
				BrightnessIndex_FF[i] = fiss.loadInt("BrightnessIndex_FF_" + i as string)
				BrightnessIndex_RT[i] = fiss.loadInt("BrightnessIndex_RT_" + i as string)
				Radius_FF_Var[i] = fiss.loadInt("Radius_FF_Var_" + i as string)
				Radius_ST_Var[i] = fiss.loadInt("Radius_ST_Var_" + i as string)
				Radius_RT_Var[i] = fiss.loadInt("Radius_RT_Var_" + i as string)
				i += 1
			endWhile
		else
			Radius_ST_Var[0] = fiss.loadInt("Radius_ST_Var")
			Radius_ST_Var[1] = fiss.loadInt("Radius_DwellingST_Var")
			Radius_ST_Var[2] = fiss.loadInt("Radius_ST_Var")
			Radius_ST_Var[3] = fiss.loadInt("Radius_NightST_Var")
			Radius_ST_Var[4] = fiss.loadInt("Radius_SneakingST_Var")
			Radius_ST_Var[5] = 1
			Radius_RT_Var[0] = fiss.loadInt("Radius_RT_Var")
			Radius_RT_Var[1] = fiss.loadInt("Radius_DwellingRT_Var")
			Radius_RT_Var[2] = fiss.loadInt("Radius_RT_Var")
			Radius_RT_Var[3] = fiss.loadInt("Radius_NightRT_Var")
			Radius_RT_Var[4] = fiss.loadInt("Radius_SneakingRT_Var")
			Radius_RT_Var[5] = 1
			i = 0
			While i < 5 	;_Condition_
				Radius_FF_Var[i] = fiss.loadInt("Radius_FF_Var")
				i += 1
			endWhile
			Radius_FF_Var[5] = 1
		endif
		
		string result = fiss.endLoad()
		if result != ""
			Debug.Trace("Error loading user settings: " + result)
			return false
		endif
	endif
	return true
endFunction

bool function CheckFISS()
	FISSInterface fiss = FISSFactory.getFISS()
	if !fiss
		return false
	else
		fiss.beginLoad("DwemerNabee.xml")
		string result = fiss.endLoad()
		if result != ""
			return false
		else
			return true
		endif
	endif
endFunction